;
        title   GeneSys Editor+, 1.3.0
; ___________________________________________________
;|                                                   |
;| GeneSys Editor+, 1.3.0              Gene Brennick |
;| pbrennick@verizon.net    http://www.pbrennick.com |
;|___________________________________________________|
;|                                                   |
;| Version key is as follows, GeneSys Editor+ a.b.c  |
;|           a:  a major change to the GUI           |
;|           b:  functions added and/or changed      |
;|           c:  bug fixes                           |
;|                                                   |
;| Version History:                                  |
;| September 23, 2003 Reworked and cleaned up the    |
;|                    code to make it more readable. |
;|                                                   |
;| February 12, 2002  Major rewrite and first        |
;|                    release of the software        |
;|                    Version tracking starts        |
;|                    from this point, on.           |
;|                                                   |
;| This nice little editor is used to create Tab     |
;| Delimited text files suitable for assemblers and  |
;| compilers.  It can be used to create/modify very  |
;| large documents making it a powerful editor.      |
;|                                     Editor's Note |
;|___________________________________________________|
;|                                                   |
        .486      ; Maintain downwards compatibility |
        .model  flat, stdcall  ; 32 bit memory model |
        option  casemap:none   ; Case Sensitive == 1 |
;|___________________________________________________|
;
;       Include Files
;       ----------------------------------------
        include \masm32\include\windows.inc
        include \masm32\include\user32.inc
        include \masm32\include\kernel32.inc
        include \masm32\include\shell32.inc
        include \masm32\include\comctl32.inc
        include \masm32\include\comdlg32.inc
        include \masm32\include\gdi32.inc
        include \masm32\include\masm32.inc
        include \masm32\include\shlwapi.inc
        include \masm32\include\advapi32.inc
;
;       Libraries
;       ----------------------------------------
        includelib  \masm32\lib\user32.lib
        includelib  \masm32\lib\kernel32.lib
        includelib  \masm32\lib\shell32.lib
        includelib  \masm32\lib\comctl32.lib
        includelib  \masm32\lib\comdlg32.lib
        includelib  \masm32\lib\gdi32.lib
        includelib  \masm32\lib\masm32.lib
        includelib  \masm32\lib\shlwapi.lib
        includelib  \masm32\lib\advapi32.lib
;
; Prototype, Macro, and Data sections, index to internal procedures
;-----------------------------------------------;
AboutDlgProc    PROTO  hWnd:HWND, iMsg:DWORD, wParam:WPARAM, lParam:LPARAM
AddLineItem     PROTO
AddSeparator    PROTO
AppendToMenu    PROTO
AsciiDlg        PROTO :DWORD, :DWORD, :DWORD, :DWORD
AsciiProc       PROTO :DWORD, :DWORD, :DWORD, :DWORD
BaseAscii       PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD
ChangeCase      PROTO
DlgProc         PROTO :DWORD, :DWORD, :DWORD, :DWORD
DoPageSU        PROTO
DoToolBar       PROTO :DWORD, :DWORD
EnableDisable   PROTO
ErrorMsg        PROTO
Find            PROTO :DWORD
FindDlgProc     PROTO :DWORD, :DWORD, :DWORD, :DWORD
GetRegKeyDW     PROTO :DWORD, :DWORD, :DWORD
GetRegKeysz     PROTO :DWORD, :DWORD, :DWORD, :DWORD
GtFrmRegistry   PROTO
LoadFile        PROTO :DWORD
LoadMRUFiles    PROTO
LowerCase       PROTO
OpenEdit        PROTO
OutputMake      PROTO :DWORD, :DWORD
PrintProc       PROTO
QFour           PROTO
SaveEdit        PROTO
SaveEditAs      PROTO
SaveMRUFiles    PROTO
SavToRegistry   PROTO
SetFormat       PROTO :DWORD
SetRegKeyDW     PROTO :DWORD, :DWORD, :DWORD
SetRegKeysz     PROTO :DWORD, :DWORD, :DWORD, :DWORD
SetWinCaption   PROTO
ShowFont        PROTO
ShowPosition    PROTO
ShowTools       PROTO
SpecialProc     PROTO :DWORD, :DWORD, :DWORD, :DWORD
TipsDlg         PROTO :DWORD, :DWORD, :DWORD, :DWORD
WantToSave      PROTO
WinMain         PROTO :DWORD, :DWORD, :DWORD, :DWORD
WndProc         PROTO :DWORD, :DWORD, :DWORD, :DWORD
WordWrap        PROTO
;
; Macro Section
;---------------------------------------;
MsgBox  MACRO   Resource:req, Title:=<ERROR>, Flags:=<MB_OK or MB_ICONEXCLAMATION>
        mov     eax, Resource
        lea     ebx, Title
        mov     ecx, Flags
        call    ErrorMsg
        EndM
;
MOVmw   MACRO Var1, Var2                ; Macro
        pushad                          ; Save flags
        lea  esi, Var2                  ; Get passed argument #1
        lea  edi, Var1                  ; Get passed argument #2
        REPEAT  2                       ; Repeat twice, as a subroutine
        mov  al, [esi]                  ; Get byte value of word data
        mov  [edi], al                  ; Store byte value of word data
        inc  esi                        ; Update the source pointer
        inc  edi                        ; Update the destination pointer
        ENDM                            ; Macro exit of repeats
        popad                           ; Restore Flags
        ENDM                            ; Macro exit
;
m2m     MACRO M1, M2                    ; Macro
        push M2                         ; Get passed argument #1
        pop  M1                         ; Get passed argument #2
        ENDM                            ; Macro exit
;
EditMsg MACRO msg:req,wparam:=<0>,lparam:=<0>       ; Macro
        inv  SendMessage, hREd, msg, wparam, lparam ; Send message to edit control
        ENDM                            ; Macro exit
;
MOVmd   MACRO   Var1, Var2
        push    Var2
        pop     Var1
        ENDM
;
.const
;---------------------------------------;
TM_PLAINTEXT        equ 1
inv                 equ invoke          ; The finger saver!!
IDB_TBRBMP          equ 150             ; Toolbar bitmap
IDR_ACCEL           equ 200             ; Accelerator Table
;
;Help Stuff
;---------------------------------------;
IDC_SHORTS          equ 3003            ; Shortcuts Button
IDC_REPORT          equ 3004            ; Error Reporting Button
IDC_NOTES           equ 3005            ; Notes Button
IDC_ABOUT           equ 3006            ; About Button
;
; Used by Find and/or Replace
;---------------------------------------;
IDD_FINDDLG         equ 2000            ; Dialog Box
IDD_ASCII           equ 2020            ; Dialog id of key ascii dialog
IDC_FINDTEXT        equ 2001            ; Edit Box
IDC_BTN_REPLACE     equ 2007            ; Button
IDC_REPLACETEXT     equ 2002            ; Edit Box
IDC_REPLACESTATIC   equ 2009            ; Text Box
IDC_BTN_REPLACEALL  equ 2008            ; Button
IDC_CHK_WHOLEWORD   equ 2004            ; Checkbox
IDC_CHK_MATCHCASE   equ 2003            ; Checkbox
IDC_RBN_DOWN        equ 2005            ; Radio Button
IDC_RBN_UP          equ 2006            ; Radio Button
;
; Used by the Editor
;---------------------------------------;
IDD_DLG             equ 1000            ; Application GUI
IDC_SBR             equ 1003            ; Statusbar Window
IDC_TBR             equ 1001            ; Toolbar Window
IDC_RED             equ 1002            ; Edit Window
IDC_OK              equ 123             ; 'Okay' Pushbutton
IDC_CANCEL          equ 124             ; 'Cancel' Pushbutton
IDD_LINENUMBER      equ 125             ; 'Goto Line' Dialog box
IDC_LINENUMBER      equ 126             ; 'Goto Line' Edit Control
;
; Used by the Menu
;---------------------------------------;
IDM_NEW             equ 10001           ; New
IDM_OPEN            equ 10002           ; Open
IDM_SAVE            equ 10003           ; Save
IDM_SAVEAS          equ 10004           ; Save As
IDM_PRINT           equ 10005           ; Print
IDM_PSETUP          equ 10120           ; Page Setup
IDM_EXIT            equ 10006           ; Exit
IDM_UNDO            equ 10101           ; Undo
IDM_REDO            equ 10102           ; Redo
IDM_DELETE          equ 10103           ; Delete
IDM_CUT             equ 10104           ; Cut
IDM_COPY            equ 10105           ; Copy
IDM_PASTE           equ 10106           ; Paste
IDM_SELECTALL       equ 10107           ; Select All
IDM_FIND            equ 10108           ; Find
IDM_FINDNEXT        equ 10110           ; Find Next
IDM_FINDPREV        equ 10111           ; Find Previous
IDM_REPLACE         equ 10109           ; Replace
IDM_WWRAP           equ 10112           ; WordWrap
IDM_SETFGCOLOR      equ 10113           ; Set Foreground Color
IDM_SETBGCOLOR      equ 10114           ; Set Background Color
IDM_FLIPCASE        equ 10115           ; Flip Case
IDM_TOLOWERCASE     equ 10116           ; Convert to Lowercase
IDM_TOUPPERCASE     equ 10117           ; Convert to Uppercase
IDM_TOOLBAR         equ 10008           ; Toolbar On/Off
IDM_STATUSBAR       equ 10009           ; Statusbar On/Off
IDM_FONT            equ 10007           ; Select Font
IDM_HELP_ABOUT      equ 10201           ; About
IDM_ASCII           equ 10202           ; Key Code To ASCII Converter
IDM_GOTOLINE        equ 10118           ; Goto Line
IDM_MENU            equ 10000           ; Menu
IDM_HELP            equ 10119           ; Help System
IDM_BUGS            equ 10121           ; OK, What's Your Sob Story...Sheesh!
IDM_HOMEPAGE        equ 10122           ; Load My WebPage
IDC_URL             equ 9
IDC_EXIT            equ 3002
;
IDM_MAKE_COMPILE    equ 12001
IDM_MAKE_ASSEMBLE   equ 12000
IDM_MAKE_LINK       equ 12002
;
; Structure for ToolBar buttons
;---------------------------------------
tbrbtns TBBUTTON    <0, 0, TBSTATE_ENABLED, TBSTYLE_SEP, 0, 0>
        TBBUTTON    <6, IDM_NEW, TBSTATE_ENABLED, TBSTYLE_BUTTON, 0, 0>
        TBBUTTON    <7, IDM_OPEN, TBSTATE_ENABLED, TBSTYLE_BUTTON, 0, 0>
        TBBUTTON    <8, IDM_SAVE, TBSTATE_ENABLED, TBSTYLE_BUTTON, 0, 0>
        TBBUTTON    <0, 0, TBSTATE_ENABLED, TBSTYLE_SEP, 0, 0>
        TBBUTTON    <0, IDM_CUT, TBSTATE_ENABLED, TBSTYLE_BUTTON, 0, 0>
        TBBUTTON    <1, IDM_COPY, TBSTATE_ENABLED, TBSTYLE_BUTTON, 0, 0>
        TBBUTTON    <2, IDM_PASTE, TBSTATE_ENABLED, TBSTYLE_BUTTON, 0, 0>
        TBBUTTON    <0, 0, TBSTATE_ENABLED, TBSTYLE_SEP, 0, 0>
        TBBUTTON    <3, IDM_UNDO, TBSTATE_ENABLED, TBSTYLE_BUTTON, 0, 0>
        TBBUTTON    <4, IDM_REDO, TBSTATE_ENABLED, TBSTYLE_BUTTON, 0, 0>
        TBBUTTON    <5, IDM_DELETE, TBSTATE_ENABLED, TBSTYLE_BUTTON, 0, 0>
        TBBUTTON    <0, 0, TBSTATE_ENABLED, TBSTYLE_SEP, 0, 0>
        TBBUTTON    <12, IDM_FIND, TBSTATE_ENABLED, TBSTYLE_BUTTON, 0, 0>
        TBBUTTON    <13, IDM_REPLACE, TBSTATE_ENABLED, TBSTYLE_BUTTON, 0, 0>
        TBBUTTON    <0, 0, TBSTATE_ENABLED, TBSTYLE_SEP, 0, 0>
        TBBUTTON    <14, IDM_PRINT, TBSTATE_ENABLED, TBSTYLE_BUTTON, 0, 0>
        TBBUTTON    <0, 0, TBSTATE_ENABLED, TBSTYLE_SEP, 0, 0>
        TBBUTTON    <15, IDM_EXIT, TBSTATE_ENABLED, TBSTYLE_BUTTON, 0, 0>
ntbrbtns            equ 19              ; Number of buttons and separators in the toolbar
;
.data
;---------------------------------------;
RichEditDLL     db  'riched20.dll', 0   ; RichEdit DLL filename
ClassName       db  'DLGCLASS', 0       ; Classname of this application
Libname         db  'Edit.dll', 0       ; Startup Screen -> Splash.dll renamed to Edit.dll
szAssemble      db  'd:\masm32\bin\ml.exe /c /coff '
szASMName       db  128 DUP (0)
szCompile       db  'd:\masm32\bin\rc.exe /v '
szRCName        db  128 DUP (0)
szLink          db  'd:\masm32\bin\link.exe /SUBSYSTEM:WINDOWS /LIBPATH:masm32\lib '
szOBJName       db  256 DUP (0)
szPacker        db  'd:\masm32\bin\upx.exe '
szPackName      db  128 DUP (0)
Space           db  ' ', 0
RCFlag          dd  0
ASMFlag         dd  0
ErrorNo1        db  "Errors occurred", 0
ErrorNo2        db  "Errors occurred while Compiling Resources", 0
ReplyNo2        db  'This portion of the Project was built successfully!', 0
ExitCode        dd  0
AppName         db  'GeneSys Editor', 0 ; Name of this application
Dummy           db  256 dup(0)          ; Path and FileName, if any, from commandline
Ending1         db  ' *]', 0            ; One of two possible Title Bar suffix
Ending2         db  ']', 0              ; One of two possible Title Bar suffix
Prefix          db  ' - [', 0           ; End of the Constant prefix
fr              dd  0                   ; Find/Replace flags
;---------------------------------------;
; Prepare to open the file specified on ;
; the commandline by setting the        ;
; following flag.                       ;
;---------------------------------------;
bypass          db  0                   ; Flag used to bypass the 'Open File' dialog box
tempword        dd  0                   ; Used to save new line number used by Edit, Goto Line
Replace         db  'Replace ..', 0     ; Label
ProjectName     DB  256 Dup (0)
szError1        db  'The RICHED20.DLL was not found!', 0    ; Error Message
OpenFileFail    db  'Cannot open the file', 0               ; Error Message
SaveFileFail    db  'Cannot save the file', 0               ; Error Message
cantfind        db  'Sorry, cannot find that file.', 0      ; Error Message
WannaSave       db  'Want to save changes to', 0Dh, 0       ; User prompt
NewFile         db  '(Untitled)', 0     ; Default label
PathName        db  'Untitled', 248 dup(0)  ; Path and FileName defaults to 'Untitled'
szNULL          db  0                   ; Null value
command         db  "open", 0
whoami          db  "mailto:pbrennick@verizon.net", 0
browser         db  "c:\Program Files\Internet Explorer\iexplore.exe", 0
url             db  "http://www.pbrennick.com", 0
findbuff        db  256 dup(0)          ; Buffer for text to find
replacebuff     db  256 dup(0)          ; Buffer for text to replace
szFlipCase      db  255 dup(0)          ; Buffer for flipping lower case to upper and vice-versa
szTitle         db  256 dup(0)          ; Title Bar message is built here
Flag            db  0                   ; Flag used by the 'Change Case' routine
FindEnd         db  'There Are No More Matches.'            ; Message
                db  0Dh, 0Ah                                ; CRLF
                db  'Would You Like To Restart From The'    ; User Prompt
TopBot          db  ' Top? '            ; End of User Prompt
                db  0                   ; ASCIIZ
Top             db  ' Top? '            ; User Prompt modifier
Bot             db  ' Bot? '            ; User Prompt modifier
szFR            db  'Find And Replace', 0                   ; Dialog box title
hAscii          dd  0
EditPT          db  'EDIT', 0
hAsciibox       dd  0
lpAsciibox      dd  0
Misc            db  40 dup (?)
w4              dd  0
AboutName       db  "AboutDialog", 0     ; About Box Name
szOpen          db  "open", 0            ; Action to perform
;
;Complier Stuff
szQuote                 db '"',0
szSpc                   db ' ',0
;
CompileRC				db '\masm32\bin\rc /v ',0
ExtRC					db '.rc',0
ExtRes					db '.res',0
Assemble				db '\masm32\bin\ml /c /coff ',0
ExtObj					db '.obj',0
Link					db '\masm32\bin\link /SUBSYSTEM:WINDOWS /RELEASE /VERSION:4.0 /LIBPATH:\masm32\lib ',0
ExtExe					db '.exe',0
;
rsrcrc					db 'rsrc.rc',0
rsrcres					db 'rsrc.res',0
;
MakeDone				db 0Dh,'Make done.',0Dh,0
Errors					db 0Dh,'Error(s) occured.',0Dh,0
NoRC					db 0Dh,'No .rc file found.',0Dh,0
CreatePipeError			db 'Error during pipe creation',0
CreateProcessError		db 'Error during process creation',0Dh,0Ah,0
;
;Help Stuff
;---------------------------------------;
SpecialDLGName  db  'SpecialDLG', 0     ; Special Help/Information Dialog Box
szButton3       db  '  A - Select all the text.', 13, 10
                db  '  B - Select Background color.', 13, 10
                db  '  C - Copy text to the clipboard.', 13, 10
                db  '  F - Find text.', 13, 10
                db  '  G - Goto Line.', 13, 10
                db  '  K - Flip Case of selected text.', 13, 10
                db  '  L - Convert selected text to lowercase.', 13, 10
                db  '  N - New Document.', 13, 10
                db  '  O - Open file using a dialog box.', 13, 10
                db  '  P - Print.', 13, 10
                db  '  R - Replace selected text.', 13, 10
                db  '  S - Save the current document.', 13, 10
                db  '  T - Select Text color.', 13, 10
                db  '  U - Convert selected text to uppercase.', 13, 10
                db  '  V - Copy text from the clipboard.', 13, 10
                db  '  W - WordWrap toggle, click on, click off.', 13, 10
                db  '  X - Cut text from document to clipboard.', 13, 10
                db  '  Y - Redo.  Undo an undo.', 13, 10
                db  '  Z - Undo last keyboard/mouse action.', 13, 10, 13, 10
                db  'DEL - Delete selected text from document.', 13, 10
                db  'ESC - Close dialog box.', 13, 10, 13, 10
                db  ' F1 - Show Help and information screens.', 13, 10
                db  ' F3 - Find Next.', 13, 10
                db  ' F3 - +CTRL, Find previous match.', 13, 10
                db  ' F4 - +ALT, Exit this program.', 13, 10, 0
szButton4       db  'If you encounter an error, please send an e-mail to me at the address listed at the '
                db  'bottom (and top) of this help box and it will be dealt with promptly. '
                db  'Enjoy and thank you for your help.', 13, 10, 13, 10
                db  'pbrennick@verizon.net', 0
szButton5       db  'The GeneSys Editor+ can be used to create Tab Delimited text files suitable '
                db  'for streaming into assemblers and compilers, etc.  It can create and/or modify '
                db  'very large documents making it a powerful editor (not just a toy, its '
                db  'small footprint can be VERY misleading).  All that and it is FREE!!  '
                db  13, 10, 13, 10, 'As this program develops, more and more ideas occur to me or are '
                db  'suggested to me by my beta testers.  Please keep those ideas coming, I need '
                db  'that sort of help.  All ideas have value and will be saved for consideration.  '
                db  'Those that do not appear in this project will undoubtedly appear in the next.'
                db  13, 10, 13, 10, 13, 10, 'Paul E. Brennick', 0
szButton6       db  'Change Logs:', 13, 10
                db  '----------------------', 13, 10
                db  13, 10, 13, 10, 13, 10
                db  13, 10, 13, 10, 13, 10, 13, 10, 13, 10
                db  'Paul E. Brennick', 0
;
; 'Replaced Phrase' counter messaging system
;---------------------------------------;
HowMany         dd  0                   ; Replace function tracks the count here
CMessagePrefix  db  ' Replaced ', 0     ; Message prefix
HowManyASCIIZ   db  10 dup (48)         ; ASCIIZ value of 'HowMany'
CMessageSuffix  db  ' occurrence(s)', 0 ; Message suffix
ShowMessage     db  64 dup (0)          ; 'Replaced Phrase' message is built and stored here
;
; Font stuff
;---------------------------------------;
FontName        db  'Courier', 25 dup(0)    ; 32 bytes max (including ASCIIZ terminator)
FontHeight      dd  -13                 ; -12=9pt., -13=10pt., -15=11pt., etc.
FontWeight      dd  400                 ; 400=normal, 700=bold
PointSize       dd  100                 ; PointSize*10, actually
BgColor         dd  0B0FFFFh            ; Very light yellow [format is reversed in memory]
rgb             dd  800000h             ; Text Color, Navy blue [format is reversed in memory]
SetBgColor      db  0                   ; Request 'Set BGColor' flag
CustClrs        dd  16  dup(?)          ; Custom Colors storage buffer, not really used yet
FirstRun        db  0                   ; First run of this program?
Modified        db  0                   ; Document 'is modified' flag
WWrap           dd  1                   ; WordWrap toggle flag
;
; Row/Column Display
;---------------------------------------;
BinRow          dd  0                   ; Binary row value
BinRowTotal     dd  0                   ; Binary total amount of rows value
BinColumn       dd  0                   ; Binary column value
BinColumnTotal  dd  0                   ; Binary total amount of columns value
BinColOffset    dd  0                   ; Cursor position within the line
FileOff         dd  0                   ; Cursor position of line start - 1
ShowRow         db  24 dup(0)           ; Status Bar 'Row' message is built and stored here
ShowColumn      db  24 dup(0)           ; Status Bar 'Column' message is built and stored here
RowMsg          db  ' Row:  ', 0        ; Data used to build message
OfMsg           db  ' of ', 0           ; Data used to build message
Row             db  6 dup(0)            ; ASCII row value
RowTotal        db  6 dup(0)            ; ASCII total amount of rows value
ColumnMsg       db  ' Col:  ', 0        ; Data used to build message
Column          db  5 dup(0)            ; ASCII column value
ColumnTotal     db  5 dup(0)            ; ASCII total amount of columns value
;
; Statusbar Banner Stuff
;---------------------------------------;
Minute          dd  0                   ; Current minute
Counter         db  0                   ; Current message index pointer
Message1        db  ' pbrennick@verizon.net',0 ; Status Bar message
Message2        db  ' File is modified.', 0     ; Status Bar message
Message3        db  ' File is not modified.', 0 ; Status Bar message
Message4        db  ' '                         ; Status Bar message
Stuffing        db  128 dup(0)          ; Message4 and Stuffing should not be separated!
DecValue        db  10                  ; Base is 10
Delimit         db  ', ', 0             ; Delimiter used in building Message 4
EndOfString     db  ' Pt.', 0           ; Delimiter used in building Message 4
ASCIIPointSize  db  4 dup(0), 0         ; ASCII Pointsize is built and stored here
;
; Registry Stuff
;---------------------------------------;
szMRU_File1     db  256 dup(0)          ; First MRU file registration
szMRU_File2     db  256 dup(0)          ; Second MRU file registration
szMRU_File3     db  256 dup(0)          ; Third MRU file registration
szMRU_File4     db  256 dup(0)          ; Fourth MRU file registration
szMRU_File5     db  256 dup(0)          ; Fifth MRU file registration
MRUBufLen1      DWORD SIZEOF szMRU_File1 + 1    ; Size of first MRU file registration
MRUBufLen2      DWORD SIZEOF szMRU_File2 + 1    ; Size of second MRU file registration
MRUBufLen3      DWORD SIZEOF szMRU_File3 + 1    ; Size of third MRU file registration
MRUBufLen4      DWORD SIZEOF szMRU_File4 + 1    ; Size of fourth MRU file registration
MRUBufLen5      DWORD SIZEOF szMRU_File5 + 1    ; Size of fifth MRU file registration
szMRUMessage1   db  'MRU_File1', 0      ; First MRU file Registry label
szMRUMessage2   db  'MRU_File2', 0      ; Second MRU file Registry label
szMRUMessage3   db  'MRU_File3', 0      ; Third MRU file Registry label
szMRUMessage4   db  'MRU_File4', 0      ; Fourth MRU file Registry label
szMRUMessage5   db  'MRU_File5', 0      ; Fifth MRU file Registry label
MRUDump         db  256 dup(0)          ; First MRU file dump
                db  256 dup(0)          ; Second MRU file dump
                db  256 dup(0)          ; Third MRU file dump
                db  256 dup(0)          ; Fourth MRU file dump
                db  256 dup(0)          ; Fifth MRU file dump
EndOfDump       db  0                   ; End of dump flag
szMenuEntry     db  256 dup(0)          ; Pointer to menu entry
szStrLength     dd  0                   ; Amount of bytes to write for each MRU entry
hSubMenu        dd  0                   ; Handle of menu containing the MRU
itemcount       dd  0                   ; Amount of items in that subMenu
Block           dd  0                   ; Offset to MRU entries in MRUDump
isModified      dd  0                   ; Has the current file been modified?
amtAdded        dd  0                   ; Maximum amount of entries to be added to the subMenu
Partial         dd  0                   ; Amount of items to remove during MRU reset
MenuID          dd  0                   ; wParam menu selection
;
; More Registry Stuff
;---------------------------------------;
szFontName      db  32 dup(0)           ; FontName, loaded from Registry
szFontHeight    dd  0                   ; FontHeight, loaded from Registry
szFontWeight    dd  0                   ; Font Weight, loaded from Registry
szPointSize     dd  0                   ; Point Size, loaded from Registry
szBgColor       dd  0                   ; Background Color, loaded from Registry
szFgColor       dd  0                   ; Text Color, loaded from Registry
szKeyName       db  'Software\Editor+\', 0  ; Name of Registry entry for this editor
szFontMessage   db  'Character Font', 0 ; Title of Registry entry
FNBufferLength  DWORD SIZEOF szFontName + 1 ; Length of FontName string
szBGCMessage    db  'Background Color',0    ; Title of Registry entry
szFGCMessage    db  'Text Color', 0     ; Title of Registry entry
szPointMessage  db  'Point Size', 0     ; Title of Registry entry
szFHeightMsg    db  'Font Height', 0    ; Title of Registry entry
szFWeightMsg    db  'Font Weight', 0    ; Title of Registry entry
;
; Printer
;---------------------------------------;
mB              dd  0                   ; Bottom margin of printed page
mL              dd  0                   ; Left margin of printed page
mR              dd  0                   ; Right margin of printed page
mT              dd  0                   ; Top margin of printed page
RTwips1000      REAL10  1.44            ; Twips constant
w1              dd  0                   ; Scratch variable used when calculating margins
pTitle          db  'GeneSys Editor', 0 ; Document Title
Sel             dd  0                   ; Flags a 'Range' type print job, currently unused
xPerInch        dd  0                   ; Width of printable area
yPerInch        dd  0                   ; Height of printable area
;
; New Printer Stuff
;---------------------------------------
szSelect        db  'Selected Text!', 0
Head            db  256 dup (0), 0
szBuff          db  256 dup (?), 0
szWork          db  256 dup (?), 0
ExtType         db  4 dup (?), 0
ASM             DB  '.asm', 0
OBJ             DB  '.obj', 0
RES             DB  '.res', 0
EXE             DB  '.exe', 0
RC              DB  '.rc', 0
Len             dd  0
BackGC          dd  00ffffffh           ; BackGround Color
TextC           dd  00808000h           ; Text Color
SBook           dd  0
EBook           dd  0
PrtHead         dd  1
PrtColor        dd  0
cnt             dd  0
RTF             dd  0
E1              equ 1801
E2              equ 1802
E3              equ 1803
E4              equ 1804
; Equates used by the Printer Routines
cb1             equ 1303
cb2             equ 1304
rb1             equ 1306
rb2             equ 1307
rb3             equ 1308
IDC_EDIT1       equ 2011                ; ID of change print heading and goto linenumber edit ctrl
IDD_PRTHEAD         equ 2010            ; Dialog id of print heading dialog
ERROR_NO_SELECTION  equ 30012
;
.data?
;---------------------------------------;
hRichEdDLL      dd      ?               ; Handle
hInstance       dd      ?               ; Handle
CommandLine     dd      ?               ; Pointer to the commandline ( stored in PSP)
hIcon           dd      ?               ; Handle
hAccel          dd      ?               ; Handle
hWnd            HWND    ?               ; Handle
hREd            HWND    ?               ; Handle
hMenu           dd      ?               ; Handle
hFind           HWND    ?               ; Handle
FileName        db      MAX_PATH dup(?) ; Buffer for Filename w/Path
fView           dd      ?               ; Amount of items used by GUI
TabSize         dd      ?               ; Store tabsize (will be set to 4)
hFont           dd      ?               ; Handle
fres            dd      ?               ; 'Resume' Flag, used to denote the continuation of a search
sbParts         dd      4 dup(?)        ; Width of each of four parts of status bar
hover           BOOL    ?
orgStatic       DD      ?
hFinger         DD      ?
buff            db      256 dup (?)
;

; Structures used by the Editor Routines
;---------------------------------------
stin    STARTUPINFO     <?>
prin    PROCESS_INFORMATION <?>
cc      CHOOSECOLOR     <?>             ; Choose Color commdlg
charF   CHARFORMAT2     <?>             ; For EM_GETCHARFORMAT/EM_SETCHARFORMAT
cr      CHARRANGE       <?>             ; Character range
ft      FINDTEXTEX      <>              ; For EM_EXGETSEL/EM_EXSETSEL
lfnt    LOGFONT         <>              ; For CreateFontIndirect
sTime   SYSTEMTIME      <?>             ; For Current Date and Time
;
; Structures used by the Printer Routines
doci    DOCINFO         <?>             ; Docinfo (printing support)
fr_1    FORMATRANGE     <?>             ; For EM_FORMATRANGE
psd     PAGESETUPDLG    <?>             ; Page setup common dialog structure
pd      PRINTDLG        <?>             ; Print
rect_1  RECT            <?>             ; Rectangle
;
;
.code
;---------------------------------------;
start:  inv  GetModuleHandle, NULL      ; returns a module handle for this instance
        mov  hInstance, eax             ; Save handle
        inv  LoadLibrary, addr Libname  ; Splash screen
        .if !eax
          jmp     NoLib
        .endif
        inv  FreeLibrary, eax
NoLib:  inv  GetCommandLine             ; Get offset pointer to commandline
        mov  CommandLine, eax           ; Save it
        inv  InitCommonControls         ; Load common control dynamic-link library (DLL)
        inv  LoadLibrary, offset RichEditDLL    ; Map RICHED20.DLL into the address space of this process
        mov  hRichEdDLL, eax            ; Save the handle
        .if !eax                        ; If fails...
          inv  MessageBox, NULL, addr szError1, addr AppName, MB_OK or MB_ICONERROR ; Report the error
          jmp  NoGo                     ; Exit the process, close the door behind you
        .endif                          ; End of conditional
        inv  WinMain, hInstance, NULL, CommandLine, SW_SHOWDEFAULT  ; Display window and enter the message loop
        push eax                        ; Save exit value, 0==no errors, for instance
        inv  FreeLibrary, hRichEdDLL    ; Free the RICHED20.DLL resource
        pop  eax                        ; Restore exit value
NoGo:   inv  ExitProcess, eax           ; See ya!
;
;
WinMain proc    USES ESI hInst:HINSTANCE, hPrevInst:HINSTANCE, CmdLine:LPSTR, CmdShow:DWORD
;---------------------------------------;
        LOCAL   wc:WNDCLASSEX           ; This application's class, created below
        LOCAL   msg:MSG                 ; Windows messaging
        LOCAL   lpArg:DWORD             ; Scratch variable
;
        mov  wc.cbSize, sizeof WNDCLASSEX   ; Size of the class
        mov  wc.style, CS_HREDRAW or CS_VREDRAW ; Declare some styles
        mov  wc.lpfnWndProc, offset WndProc ; Points to the window procedure
        mov  wc.cbClsExtra, NULL        ; Specifies the number of extra bytes to allocate following the window-class structure
        mov  wc.cbWndExtra, DLGWINDOWEXTRA  ; Specifies the number of extra bytes to allocate following the window instance
        push hInst                      ; Save handle to instance
        pop  wc.hInstance               ; Identifies the instance that the window procedure of this class is within
        mov  wc.hbrBackground, NULL     ; Identifies the class background brush
        mov  wc.lpszMenuName, IDM_MENU  ; If this member is NULL, the window belonging to this class has no default menu
        mov  wc.lpszClassName, offset ClassName ; Specifies the window class name
        inv  LoadIcon, NULL, IDI_APPLICATION    ; Get handle of the icon
        mov  hIcon, eax                         ; Save the handle
        mov  wc.hIcon, eax                      ; Store it in the class structure
        mov  wc.hIconSm, eax                    ; Store the thumbnail's handle
        inv  LoadCursor, NULL, IDC_ARROW        ; Get cursor
        mov  wc.hCursor, eax                    ; Store it in the class structure
        inv  RegisterClassEx, addr wc           ; Register the class
        inv  CreateDialogParam, hInstance, IDD_DLG, NULL, offset WndProc, NULL  ; Create window
        mov  hWnd, eax                          ; Save the handle to the window
        inv  ShowWindow, hWnd, SW_SHOWNORMAL    ; Show the window
        inv  UpdateWindow, hWnd                 ; Update [paint] the window's client area
;
;       Get any command line filename
;       --------------------------------
        inv  PathGetArgs, CommandLine   ; Get command line, if it exists
        mov  lpArg, eax                 ; Save the pointer to the command line
        mov  esi, eax                   ; Prepare for testing
        lodsb                           ; Get a possible character into 'al'
        cmp  al, 0                      ; No command line argument?
        je   noArgs                     ; Jump if no argument
        cmp  al, 34                     ; Quotation mark?
        jne  Again                      ; Jump if no quotation mark
        inv  PathUnquoteSpaces, lpArg   ; Parse the command line, remove chaff
        mov  lpArg, eax                 ; Save the pointer to the command line
Again:  inv  exist, lpArg               ; Valid path and/or filename?
        .if eax == 1                    ; If true ...
          inv  lstrcpy, offset Dummy, lpArg ; Save filename/path from the commandline
          inv  lstrcpy, offset PathName, lpArg  ; Save filename/path from the commandline
          mov  bypass, 1                ; Open file later, when initialization is complete
        .else                           ; If false ...
          inv  MessageBox, hWnd, lpArg, ADDR cantfind, MB_OK ; Bitch about it
        .endif                          ; End of conditional
noArgs: inv  LoadMenu, hInstance, IDM_MENU  ; Menu ID
        mov  hMenu, eax                 ; Save the handle
        inv  SetMenu, hWnd, eax         ; Add the Menu to the window
        inv  GtFrmRegistry              ; Load settings from Registry
        inv  ShowWindow, hWnd, SW_SHOWNORMAL    ; Set the window's show state
        inv  UpdateWindow, hWnd         ; Send a WM_PAINT message directly to the window procedure
        inv  LoadAccelerators, hInstance, IDR_ACCEL ; Load the accelerator key table
        mov  hAccel, eax                ; Save handle to the list
        .while TRUE                     ; Parse the message buffer
          inv  GetMessage, addr msg, NULL, 0, 0 ; Check messages
          .break .if !eax               ; If no ...
          inv  IsDialogMessage, hFind, addr msg ; Dialog box message?
          .if !eax                      ; If no ...
            inv  TranslateAccelerator, hWnd, hAccel, addr msg   ; Accelerator key?
            .if !eax                    ; If no ...
              inv  TranslateMessage, addr msg   ; Translates virtual-key message into character message and place into the queue
              inv  DispatchMessage, addr msg    ; Dispatches message to the window procedure
            .endif                      ; End of conditional
          .endif                        ; End of conditional
          inv  LoadMRUFiles             ; Load MRU files from Registry
          inv  AppendToMenu             ; Store the MRU in the menu
          inv  ShowPosition             ; Display cursor coordinates on the Status Bar
          inv  EnableDisable            ; Control various buttons and menuitems
          inv  QFour                    ; Display the Statusbar messaging system
        .endw                           ; End of conditional
        mov  eax, msg.wParam            ; Get message to pass as exit code
        ret                             ; Bye
;---------------------------------------
WinMain endp
;
;
WndProc proc    USES ESI EDI hWin:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
;---------------------------------------;
        LOCAL   pt:POINT                ; Structure
        LOCAL   rect:RECT               ; Structure
        LOCAL   ht:DWORD                ; Height of window
        LOCAL   hCtl:HWND               ; Temporary handle storage (shared)
        LOCAL   chrg:CHARRANGE          ; Structure
        LOCAL   cf:CHOOSEFONT           ; Structure
        LOCAL   buffer[256]:BYTE        ; Buffer
;
        mov  eax, uMsg                  ; Get message
        .if eax==WM_INITDIALOG          ; If it is a request to initialize the window
          push hWin                     ; Save handle
          pop  hWnd                     ; Restore the handle to a new variable
          .if fr == 0                   ; Definitely the first pass?
            mov  fr, FR_DOWN            ; Default searches to downwards
          .endif                        ; End of 'first pass' conditional
          mov  fView, 3                 ; Initialize the control flag
          mov  TabSize, 4               ; Set the tab size
;         Set the toolbar buttons
          inv  GetDlgItem, hWin, IDC_TBR    ; Get handle of the toolbar
          inv  DoToolBar, hInstance, eax    ; Create the toolbar
;         Set FileName to NewFile
          inv  lstrcpy, offset FileName, offset NewFile ; Set filename to 'UNTITLED'
          inv  SetWinCaption            ; Display the filename as the caption
;         Get handle of RichEdit window and give it focus
          inv  GetDlgItem, hWin, IDC_RED    ; Get handle for the edit control
          mov  hREd, eax                ; Save the handle
          inv  SendMessage, hREd, EM_SETTEXTMODE, 0, TM_PLAINTEXT
;         Set event mask
          inv  SendMessage, hREd, EM_SETEVENTMASK, 0, ENM_SELCHANGE ; Set the event mask for the rich edit control
;         Set the text limit. The default is 64K
          inv  SendMessage, hREd, EM_LIMITTEXT, -1, 0   ; Set maximum file size to the maximum memory available
;         Create font
          inv  GtFrmRegistry            ; Load settings from Registry
          inv  lstrcpy, offset lfnt.lfFaceName, offset FontName ; Get fontname
          mov  eax, FontHeight          ; Get font height
          mov  lfnt.lfHeight, eax       ; Store the font height in the logfont structure
          mov  eax, FontWeight          ; Get font weight
          mov  lfnt.lfWeight, eax       ; Store the font weight in the logfont structure
          inv  CreateFontIndirect, offset lfnt  ; Create the font
          mov  hFont, eax               ; Store it
          inv  ShowFont                 ; Update the Status Bar Messaging
          inv  LoadMRUFiles             ; Load MRU from Registry
          mov  eax, BgColor             ; Get BackGround Color
          mov  charF.crBackColor, eax   ; Store it in the structure
          inv  SendMessage, hREd, EM_SETBKGNDCOLOR, 0, eax    ; Set background color
          mov  byte ptr FirstRun, 1     ; Used to suppress the dialog box
          call SetColor                 ; Set ForeGround Color
          mov  byte ptr FirstRun, 0     ; Clear for normal operation henceforth
;         Set font & format
          inv  SetFormat, hREd          ; Set tab stops, etc.
;         Initialize the RichEdit control
          inv  SendMessage, hREd, EM_SETMODIFY, FALSE, 0    ; Set the document to 'not modified'
          inv  SendMessage, hREd, EM_EMPTYUNDOBUFFER, 0, 0  ; Empty the undo buffer
          inv  SetFocus, hREd                               ; Set focus to the richedit control
        .elseif eax==WM_COMMAND                             ; If a command is waiting to be processed
;         Menu and toolbar has the same ID's
          mov  eax, wParam              ; Get message
          and  eax, 0FFFFh              ; Just the LSWord
          .if eax == IDM_NEW            ; New Document request?
            inv  WantToSave             ; Check state of current document, if any
            .if !eax                    ; If edit control is empty
              inv  SetWindowText, hREd, offset szNULL   ; Clear the current caption
              inv  lstrcpy, offset FileName, offset NewFile ; Set filename to 'UNTITLED'
              mov  Modified, 0          ; Reset the 'document modified' flag
              mov  Flag, 0              ; Clear the 'Set Caption' flag
              inv  SetWinCaption        ; Set the window caption
            .endif                      ; End of conditional
            inv  SetFocus, hREd         ; Set focus to the edit control
;         If a file is selected from the MRU list
;         ------------------------------
          .elseif wParam > 1200 && wParam < 1206    ; Is selection from the MRU?
            mov  eax, wParam            ; Get value
            sub  eax, 1201              ; Get index from it
            mov  Block, 0               ; Start at the beginning
            .while eax > 0              ; If still more to be parsed...
              add  Block, 256           ; Move to next entry
              dec  eax                  ; Update the counter
            .endw                       ; Continue parsing until done
            mov  esi, offset MRUDump    ; Point to the MRU database
            add  esi, Block             ; Add the offset to correct filename
            mov  edi, offset PathName   ; Offset to PathName
transfer:   mov  al, [esi]              ; Get a filename character
            mov  [edi], al              ; Store it
            inc  esi                    ; Update source pointer
            inc  edi                    ; Update destination pointer
            cmp  al,0                   ; ASCIIZ?
            jne  transfer               ; Continue transfer until terminator is found
            inv  WantToSave             ; Check for an opened, modified file
            .if !eax                    ; If check performed successfully
              inv  lstrcpy, offset Dummy, offset PathName   ; Save filename/path from the commandline
              inv  LoadFile, addr Dummy ; Go open the file
              inv  ShowTools            ; Update the available Menu Options
              inv  SetFocus, hREd       ; Set focus to the edit window
            .endif                      ; End of conditional
          .elseif eax==IDM_OPEN         ; If File Open request?
            inv  WantToSave             ; Check state of current document, if any
            .if !eax                    ; If control is empty
              inv  OpenEdit             ; Open a file
            .endif                      ; End of conditional
            inv  SetFocus, hREd         ; Set focus to the edit control
          .elseif eax==IDM_SAVE         ; If File Save request?
            inv  SaveEdit               ; Save file
            inv  SetFocus, hREd         ; Set focus to the edit window
          .elseif eax==IDM_SAVEAS       ; If File Save As request?
            inv  SaveEditAs             ; Save File As
            inv  SetFocus, hREd         ; Set focus to the edit window
          .elseif eax==IDM_GOTOLINE     ; Go To Line request?
            inv  DialogBoxParam, hInstance, IDD_LINENUMBER, hWin, OFFSET DlgProc, NULL  ; Process the request
            cmp  eax, IDCANCEL          ; Cancel?
            je   NoChange               ; Jump if cancelled
            mov  eax, tempword          ; Get line number
            dec  eax                    ; Zero base
            EditMsg EM_LINEINDEX, eax, 0    ; Get character offset to that line
            EditMsg EM_SETSEL, eax, eax ; Move to that line
NoChange: .elseif eax == IDM_HELP       ; Help, Information?
            inv  DialogBoxParam, hInstance, ADDR SpecialDLGName, 0, ADDR SpecialProc, 0 ; Show Information Dialog Box
          .elseif eax == IDM_BUGS       ; Bug Reports or just plain chit chat
            inv  ShellExecute, NULL, addr command, addr whoami, NULL, NULL, SW_RESTORE
          .elseif eax == IDM_HOMEPAGE   ; Check for updates
            inv  ShellExecute, NULL, addr command, addr browser, addr url, NULL, SW_RESTORE
          .elseif eax==IDM_PRINT        ; Print Document request?
            call PrintProc              ; Print the document
          .elseif eax == IDM_PSETUP     ; Page Setup?
            call DoPageSU               ; Do Page Setup
          .elseif eax==IDM_EXIT         ; Quit?
            inv  SendMessage, hWin, WM_CLOSE, 0, 0  ; Close the file
          .elseif eax==IDM_UNDO         ; Undo?
            inv  SendMessage, hREd, EM_UNDO, 0, 0   ; Undo the last action
          .elseif eax==IDM_REDO         ; Redo?
            inv  SendMessage, hREd, EM_REDO, 0, 0   ; Redo the last action
          .elseif eax==IDM_DELETE       ; Delete text?
            inv  SendMessage, hREd, EM_REPLACESEL, TRUE, 0  ; Delete the selected text
          .elseif eax==IDM_CUT          ; Cut text?
            inv  SendMessage, hREd, WM_CUT, 0, 0    ; Remove the selected text from the control and place it in the clipboard
          .elseif eax==IDM_COPY         ; Copy text?
            inv  SendMessage, hREd, WM_COPY, 0, 0   ; Copy selected text from the control to the clipboard
          .elseif eax==IDM_PASTE        ; Select Paste?
            inv  SendMessage, hREd, WM_PASTE, 0, 0  ; Paste the contents of the clipboard into the edit control
          .elseif eax == IDM_WWRAP      ; Word Wrap?
            call WordWrap               ; Go toggle Word Wrap mode
          .elseif eax == IDM_SETFGCOLOR ; Format, Text Color?
            call SetColor               ; Go change text color
            inv  SavToRegistry          ; Update the Registry
          .elseif eax == IDM_SETBGCOLOR ; Format, Background Color?
            mov  SetBgColor, 1          ; Set flag to change background color
            call SetColor               ; Go change background color
            mov  SetBgColor, 0          ; Clear the flag
            inv  SavToRegistry          ; Update the Registry
          .elseif eax == IDM_FLIPCASE   ; Flip Case?
            mov  byte ptr Flag, 3       ; Set the flag
            inv  ChangeCase             ; Routine used to change case of a string
          .elseif eax == IDM_TOUPPERCASE    ; Change to UpperCase?
            mov  byte ptr Flag, 2       ; Set the flag
            inv  ChangeCase             ; Routine used to change case of a string
          .elseif eax == IDM_TOLOWERCASE    ; Change to LowerCase?
            mov  byte ptr Flag, 1       ; Set the flag
            inv  ChangeCase             ; Routine used to change case of a string
          .elseif eax==IDM_SELECTALL    ; Select all text in the control
            mov  chrg.cpMin, 0          ; Text start
            mov  chrg.cpMax, -1         ; Text end
            inv  SendMessage, hREd, EM_EXSETSEL, 0, addr chrg   ; Select all the text
          .elseif eax==IDM_FIND         ; Find Text?
            inv  SendMessage, hREd, EM_EXGETSEL, 0, offset cr   ; Get start and ending positions of highlighted text
            mov  eax, cr.cpMax          ; Get end position
            sub  eax, cr.cpMin          ; Minus the start position
            .if eax                     ; Anything highlighted?
              .if eax < 255             ; If yes and in range...
                inv  SendMessage, hREd, EM_GETSELTEXT, 0, addr findbuff ; Get selected text
              .endif                    ; End of conditional
            .endif                      ; End of conditional
            .if hFind==0                ; If dialog box is not showing ...
              inv  CreateDialogParam, hInstance, IDD_FINDDLG, hWin, offset FindDlgProc, FALSE   ; Show it
            .else                       ; If it is ...
              inv  SetFocus, hFind      ; Set focus to it
            .endif                      ; End of conditional
          .elseif eax==IDM_REPLACE      ; Replace Text?
            xor  eax, eax               ; Clear the counter
            mov  HowMany, eax           ; Store the cleared value (zero the counter)
            inv  SendMessage, hREd, EM_EXGETSEL, 0, offset cr   ; Get start and ending positions of highlighted text
            mov  eax, cr.cpMax          ; Get end position
            sub  eax, cr.cpMin          ; Minus the start position
            .if eax                     ; Anything highlighted?
              .if eax < 255             ; If yes and in range...
                inv  SendMessage, hREd, EM_GETSELTEXT, 0, addr findbuff ; Get selected text
              .endif                    ; End of conditional
            .endif                      ; End of conditional
            .if hFind==0                ; If dialog box is not showing ...
              inv  CreateDialogParam, hInstance, IDD_FINDDLG, hWin, addr FindDlgProc, TRUE  ; Show it
            .else                       ; If it is...
              inv  SetFocus, hFind      ; Set focus to it
            .endif                      ; End of conditional
          .elseif eax==IDM_FINDNEXT     ; Find next occurrence?
            mov  al, findbuff           ; Get first character in the buffer
            .if al                      ; Valid?
              inv  Find, FR_DOWN        ; Continue the search if it is valid
            .endif                      ; End of conditional
          .elseif eax==IDM_FINDPREV     ; Find previous occurrence?
            mov  al, findbuff           ; Get first character in the buffer
            .if al                      ; Valid?
              inv  Find, 0              ; Continue the search if it is valid
            .endif                      ; End of conditional
          .elseif eax==IDM_TOOLBAR      ; View Toolbar?
            inv  GetDlgItem, hWin, IDC_TBR  ; Get handle of the toolbar control
            mov  hCtl, eax              ; Save the handle
            xor  fView, 1               ; Toolbar = 1
            mov  eax, fView             ; Save it
            and  eax, 1                 ; Toolbar bit set?
            .if eax                     ; If yes ...
              inv  ShowWindow, hCtl, SW_SHOWNA  ; Show it
            .else                       ; Or
              inv  ShowWindow, hCtl, SW_HIDE    ; Hide it
            .endif                      ; End of conditional
            inv  SendMessage, hWin, WM_SIZE, 0, 0   ; Size the control
          .elseif eax==IDM_STATUSBAR    ; View Statusbar?
            inv  GetDlgItem, hWin, IDC_SBR  ; Get handle of the Statusbar control
            mov  hCtl, eax              ; Save the handle
            xor  fView, 2               ; Statusbar = 2
            mov  eax, fView             ; Save it
            and  eax, 2                 ; Statusbar bit set?
            .if eax                     ; If yes ...
              inv  ShowWindow, hCtl, SW_SHOWNA  ; Show it
            .else                       ; Or
              inv  ShowWindow, hCtl, SW_HIDE    ; Hide it
            .endif                      ; End of conditional
            inv  SendMessage, hWin, WM_SIZE, 0, 0   ; Tell the control to size itself
          .elseif eax==IDM_FONT         ; Change Font?
            inv  RtlZeroMemory, addr cf, sizeof cf  ; Clear the structure
            mov  cf.lStructSize, sizeof cf  ; Store size of structure
            mov  eax, hWin              ; Get application's handle
            mov  cf.hwndOwner, eax      ; Store it in the structure
            mov  cf.lpLogFont, offset lfnt  ; Store logfont pointer
            mov  cf.Flags, CF_SCREENFONTS or CF_EFFECTS or CF_INITTOLOGFONTSTRUCT   ; Set flags as masks
            mov  eax, rgb               ; Get foreground color
            mov  cf.rgbColors, eax      ; Store it in the structure
            inv  ChooseFont, addr cf    ; Display the Choose Font dialog box
            .if eax                     ; If successful ...
              inv  DeleteObject, hFont  ; Delete brush
              inv  CreateFontIndirect, offset lfnt  ; Create font
              mov  hFont, eax           ; Store the font
              mov  eax, cf.rgbColors    ; Get textcolor
              mov  rgb, eax             ; Store it
              mov  eax, cf.iPointSize   ; Get PointSize*10
              mov  PointSize, eax       ; Save it
              inv  ShowFont             ; Display it in the Statusbar
              inv  SetFormat, hREd      ; Set tabstops, etc.
              inv  lstrcpy, addr FontName, addr lfnt.lfFaceName
              inv  SavToRegistry        ; Save the new font into the Registry
              inv  ShowFont             ; Build the FontName and size into a string
              inv  QFour                ; Display the new font in the status bar
            .endif                      ; End of conditional
            inv  SetFocus, hREd         ; Set focus to the edit window
          .elseif eax==IDM_ASCII        ; Roxanne
            push    0
            push    offset AsciiDlg
            push    hWnd
            push    IDD_ASCII
            push    hInstance
            call    CreateDialogParam
            mov     hAscii, eax
            inv     CreateWindowEx, WS_EX_CLIENTEDGE, addr EditPT, 0,
                    WS_CHILD or WS_VISIBLE or ES_CENTER, 39, 32, 22, 20, hAscii, IDM_ASCII, hInstance, 0
            mov     hAsciibox, eax
            inv     SetFocus, eax
            inv     SetWindowLong, hAsciibox, GWL_WNDPROC, AsciiProc
            mov     lpAsciibox, eax
          .elseif eax==IDM_HELP_ABOUT   ; Help?
            inv  CreateDialogParam, hInstance, addr AboutName, hWnd, OFFSET AboutDlgProc, NULL
          .elseif Eax == IDM_MAKE_ASSEMBLE  ; Assemble the ASM file[s]?
            invoke OutputMake,IDM_MAKE_ASSEMBLE,offset FileName
          .elseif Eax == IDM_MAKE_COMPILE   ; Compile the RC file?
            invoke OutputMake,IDM_MAKE_COMPILE,offset FileName
          .elseif Eax == IDM_MAKE_LINK  ; Link the OBJ and RES file[s]?
            invoke OutputMake,IDM_MAKE_LINK,offset FileName
          .endif                        ; End of conditional
ByeBye: .elseif eax==WM_NOTIFY          ; Notify?
          mov  edx, lParam              ; Get subcommand
          mov  eax, (NMHDR ptr [edx]).code  ; Save it
          .if eax==TTN_NEEDTEXT         ; Notification message used to retrieve text
;           Toolbar tooltip
            mov  edx, (NMHDR ptr [edx]).idFrom  ; Save it
            inv  LoadString, hInstance, edx, addr buffer, sizeof buffer ; Get the message
            lea  eax, buffer            ; Initialize the buffer pointer
            mov  edx, lParam            ; Get subcommand
            mov  (TOOLTIPTEXT ptr [edx]).lpszText, eax  ; Display tooltip
          .elseif wParam==IDC_RED       ; RichEdit Control?
;           Auto horizontal scroll text into view
            inv  GetCaretPos, addr pt   ; Store Caret Position
            inv  SendMessage, hREd, EM_GETRECT, 0, addr rect    ; Get window coordinates
            mov  eax, rect.right        ; save the position of the right edge
            sub  eax, pt .x             ; Minus the width of the control
            .if eax<20                  ; If less than 20 pixels
              inc  rect.left            ; Add one to the left edge value
              inc  rect.top             ; Add one to the top edge value
              sub  rect.right, 70       ; Subtract 70 from the right edge
              inv  SendMessage, hREd, EM_SETRECT, 0, addr rect  ; Set the window borders
              inv  SendMessage, hREd, EM_SCROLLCARET, 0, 0  ; Scroll the caret onto the control
              add  rect.right, 70       ; Restore the right edge to what it was originally
              inv  SendMessage, hREd, EM_SETRECT, 0, addr rect  ; Set the window borders
            .endif                      ; End of conditional
          .endif                        ; End of conditional
        .elseif eax == WM_SETFOCUS      ; Set focus request?
          inv     SetFocus, hREd        ; Set focus to the edit control
        .elseif eax == WM_SIZE          ; If the window has changed size ...
          mov  eax, fView               ; Initialize the control flag
          and  eax, 1                   ; Toolbar = 1
          .if eax                       ; If Toolbar ...
;           Resize toolbar
            inv  GetDlgItem, hWin, IDC_TBR  ; Get handle of the Toolbar
            mov  hCtl, eax              ; Save it
            inv  MoveWindow, hCtl, 0, 0, 0, 0, TRUE ; Change the position and dimensions of the specified window
;           Get height of toolbar
            inv  GetWindowRect, hCtl, addr rect ; Get dimension of the Toolbar
            mov  eax, rect.bottom       ; Get value of the bottom of the window
            sub  eax, rect.top          ; Get value of the top of the window
          .endif                        ; End of conditional
          push eax                      ; Save Toolbar height
          mov  eax, fView               ; Get new mask value
          and  eax, 2                   ; Statusbar?
          .if eax                       ; If yes
;           Resize and partition the Statusbar
            inv  GetDlgItem,hWin,IDC_SBR    ; Get handle of the Statusbar
            mov  hCtl, eax              ; Save handle of the Statusbar
            mov  eax, rect.right        ; Right edge of control ...
            sub  eax, rect.left         ; Minus the left edge equals width of Statusbar
            shr  eax, 2                 ; /4 equals width of each partition
            mov  ecx, eax               ; Save partition width
            mov  sbParts, eax           ; Set right edge of Partition #1
            add  eax, ecx               ; Get right edge of Partition #2
            mov  [sbParts+4], eax       ; Store it in the Partition table
            add  eax, ecx               ; Get right edge of Partition #3
            mov  [sbParts+8], eax       ; Store it in the Partition table
            mov  [sbParts+12], -1       ; Partition #4 extends to the end
            inv  SendMessage, hCtl, SB_SETPARTS, 4, addr sbParts    ; Partition the Statusbar
            inv  MoveWindow, hCtl, 0, 0, 0, 0, TRUE ; Display the Statusbar
;           Get height of the statusbar
            inv  GetWindowRect, hCtl, addr rect ; Get dimensions of the Statusbar
            mov  eax, rect.bottom       ; Get value of the bottom of the Statusbar
            sub  eax, rect.top          ; Minus the top
          .endif                        ; End of conditional
          push eax                      ; Save Statusbar height
;         Get size of windows client area
          inv  GetClientRect, hWin, addr rect   ; Get dimensions of the edit control
;         Subtract height of statusbar from bottom
          pop  eax                      ; Restore Statusbar height
          sub  rect.bottom, eax         ; Get bottom of the Edit Control
;         Add height of toolbar to top  ; Add height of the control
          pop  eax                      ; Restore Toolbar height
          add  rect.top, eax            ; Get top of the Edit Control
;         Get new height of RichEdit window
          mov  eax, rect.bottom         ; Get value of the bottom of the Statusbar
          sub  eax, rect.top            ; Minus the top
          mov  ht, eax                  ; Save the height
;         Resize RichEdit window
          inv  MoveWindow, hREd, 0, rect.top, rect.right, ht, TRUE  ; Change the position and dimensions of the specified window

          inv  GetDlgItem,hWin,IDC_SBR  ; Get handle of the Statusbar
          mov  hCtl, eax                ; Save handle of the Statusbar
          inv  MoveWindow, hCtl, 0, 0, 0, 0, TRUE   ; Display the Statusbar

        .elseif eax==WM_CLOSE           ; Close?
          inv  WantToSave               ; Check state of current document, if any
          .if !eax                      ; If all is okay
            inv  SavToRegistry          ; Store any changes in the Registry
            inv  DestroyWindow, hWin    ; Close down the window
          .endif                        ; End of conditional
        .elseif eax==WM_DESTROY         ; Destroy the window
          inv  SavToRegistry            ; Store any changes in the Registry
          inv  DeleteObject, hFont      ; Delete the font
          inv  PostQuitMessage, NULL    ; Tell Windows that this thread has made a request to terminate (quit)
        .elseif eax==WM_CONTEXTMENU     ; Notifies a window that the user clicked the right mouse button (right clicked) in the window.
          mov  eax, wParam              ; Get message
          .if eax==hREd                 ; If Edit Control
            mov  eax, lParam            ; Get subcommand
            and  eax, 0FFFFh            ; Just the LSWord
            mov  pt .x, eax              ; Save 'x' coordinate
            mov  eax, lParam            ; Get subcommand
            shr  eax, 16                ; Just the MSWord
            mov  pt.y, eax              ; Save 'y' coordinate
            inv  GetMenu, hWin          ; Get menu handle
            inv  GetSubMenu, eax, 1     ; Retrieves the handle of the drop-down menu or submenu activated by the specified menu item.
            inv  TrackPopupMenu, eax, TPM_LEFTALIGN or TPM_RIGHTBUTTON, pt .x, pt.y, 0, hWin, 0 ; Displays a shortcut menu at the specified location
            xor  eax, eax               ; Errorlevel==0
            ret                         ; Return
          .endif                        ; End of conditional
        .else                           ; Else ...
          .if bypass == 1               ; Is a file waiting to be opened?
            mov  bypass, 0              ; Clear the 'File Open' flag
            inv  LoadFile, addr Dummy   ; Go open the file
            inv  lstrcpy, Addr buffer, Addr Dummy ; Get filename and path
            inv  lstrlen, Addr buffer   ; Get length of fully qualified path and filename
            lea  edi, buffer            ; Point to start of path
            add  edi, eax               ; Now at end of path
            sub  edi, 4                 ; Move to extension start
            mov  ecx, 4                 ; 4 characters to transfer
            lea  esi, ExtType           ; Destination
next:       mov  al, [edi]              ; Get character
            mov  [esi], al              ; Put character
            inc  esi                    ; update position
            inc  edi                    ; update position
            loop next                   ; Copy four characters
            inv  ShowTools              ; Update the available Menu Options
            inv  SetFocus, hREd         ; Set focus to the edit window
          .endif                        ; End of conditional
          inv  DefWindowProc, hWin, uMsg, wParam, lParam    ; Deletes a logical pen, brush, font, bitmap, region, or palette
          ret                           ; Return to caller
        .endif                          ; End of conditional
        xor  eax, eax                   ; Errorlevel==0
        ret                             ; Return to caller
;---------------------------------------;
WndProc endp
;
;
StreamInProc    proc    hFile:DWORD, pBuffer:DWORD, NumBytes:DWORD, pBytesRead:DWORD
;---------------------------------------;
        inv  ReadFile, hFile, pBuffer, NumBytes, pBytesRead, 0  ; Read In the file
        xor  eax, 1                     ; Set Errorlevel
        ret                             ; Return
;---------------------------------------;
StreamInProc    endp
;
;
StreamOutProc   proc    hFile:DWORD, pBuffer:DWORD, NumBytes:DWORD, pBytesWritten:DWORD
;---------------------------------------
        inv  WriteFile, hFile, pBuffer, NumBytes, pBytesWritten, 0  ; Write In the file
        xor  eax, 1                     ; Set Errorlevel
        ret                             ; Return
;---------------------------------------;
StreamOutProc   endp
;
;
SetWinCaption   proc
;---------------------------------------
;       Build and display the Window's Caption
        inv  RtlZeroMemory, addr szTitle, sizeof szTitle ; Clear the Title
        inv  lstrcpy, addr szTitle, offset AppName  ; Start with the name of this application
        inv  lstrcat, addr szTitle, offset Prefix   ; Add a hyphen and a left bracket
        inv  lstrcat, addr szTitle, offset FileName ; Add the Filename w/Path
        .if Modified == 1                           ; If the document is modified...
          inv  lstrcat, addr szTitle, offset Ending1 ; Add an asterisk and a right bracket
        .else                                       ; Or...
          inv  lstrcat, addr szTitle, offset Ending2 ; Add a right bracket
        .endif                                      ; End of conditional
        inv  SetWindowText, hWnd, addr szTitle      ; Display the message on the TitleBar
        ret                             ; Return  to caller
;---------------------------------------;
SetWinCaption   endp
;
;
SaveFile    proc    lpFileName:DWORD
;---------------------------------------;
        LOCAL   hFile:DWORD             ; Handle of curremt document
        LOCAL   editstream:EDITSTREAM   ; Contains information about a data stream used with a rich edit control
;
        inv  CreateFile, lpFileName, GENERIC_WRITE, FILE_SHARE_READ, NULL, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, 0  ; Create the file context
        .if eax != INVALID_HANDLE_VALUE ; If handle is valid
          mov  hFile, eax               ; Save the handle
;         Stream the text to the file
          mov  editstream.dwCookie, eax ; Store the handle
          mov  editstream.pfnCallback, offset StreamOutProc
          inv  SendMessage, hREd, EM_STREAMOUT, SF_TEXT, addr editstream    ; Contains information about a data stream used with a rich edit control
          inv  CloseHandle, hFile       ; Close the file
;         Set the modify state to false
          inv  SendMessage, hREd, EM_SETMODIFY, FALSE, 0    ; Set document state to 'not modified'
          mov  Modified, 0              ; Reset the 'Document Modified' flag
          mov  Flag, 0                  ; Reset the Enable/Disable flag
          inv  SetWinCaption            ; Show the Window's Caption
          mov  eax, FALSE               ; Set Errorlevel
        .else                           ; Or
          inv  MessageBox, hWnd, offset SaveFileFail, offset AppName, MB_OK ; Bitch about the failed Save
          mov  eax, TRUE                ; Set Errorlevel
        .endif                          ; End of conditional
        ret                             ; Return  to caller
;---------------------------------------;
SaveFile    endp
;
;
SaveEditAs  proc
;---------------------------------------;
        LOCAL   ofn:OPENFILENAME        ; Structure
        LOCAL   buffer[MAX_PATH]:BYTE   ; Temporary buffer
;
        inv  RtlZeroMemory, addr ofn, sizeof ofn    ; Zero out the ofn structure
;       Setup the ofn struct
        mov  ofn.lStructSize, sizeof ofn    ; Store size of structure
        push hWnd                       ; Save handle of window
        pop  ofn.hwndOwner              ; Restore it into the structure
        push hInstance                  ; Save instance of this application
        pop  ofn.hInstance              ; Restore it into the structure
        mov  ofn.lpstrFilter, NULL      ; Clear the filter mask
        mov  buffer[0], 0               ; Clear the buffer
        lea  eax, buffer                ; Get location of the buffer
        mov  ofn.lpstrFile, eax         ; Store location in the structure
        mov  ofn.nMaxFile, sizeof buffer    ; Store buffer size in the structure
        mov  ofn.Flags, OFN_FILEMUSTEXIST or OFN_HIDEREADONLY or OFN_PATHMUSTEXIST or OFN_OVERWRITEPROMPT   ; Store flags in the structure
        mov  ofn.lpstrDefExt, NULL      ; No default extension
        inv  GetSaveFileName, addr ofn  ; Show save as dialog box
        .if eax                         ; If getting a name was successful ...
          inv  SaveFile, addr buffer    ; Save the file
          .if !eax                      ; If successful ...
;           The file was saved
            mov  Modified, 0            ; Set file status as 'not modified'
            mov  Flag, 0                ; Clear the 'Set Caption' flag
            inv  lstrcpy, offset FileName, addr buffer
            inv  SetWinCaption          ; Update the caption
            mov  eax, FALSE             ; Set Errorlevel
          .endif                        ; End of conditional
        .else                           ; Or ...
          mov  eax, TRUE                ; Set Errorlevel
        .endif                          ; End of conditional
        ret                             ; Return
;---------------------------------------
SaveEditAs  endp
;
;
SaveEdit    proc
;---------------------------------------
        inv  lstrcmp, offset FileName, addr NewFile ; Check if filename is (Untitled)
        .if eax                             ; If the file has a name ...
          inv  SaveFile, offset FileName    ; Save the file using the existing name
        .else                           ; Else ...
          inv  SaveEditAs               ; Select a filename
        .endif                          ; End of conditional
        ret                             ; Return
;---------------------------------------;
SaveEdit  endp
;
;
WantToSave  proc
;---------------------------------------;
        LOCAL   buffer[512]:BYTE        ; Temporary buffer
        LOCAL   buffer1[2]:BYTE         ; Temporary buffer
;
        inv  SendMessage, hREd, EM_GETMODIFY, 0, 0  ; Get document state
        .if eax                         ; If document has been modified
          inv  lstrcpy, addr buffer, offset WannaSave   ; Build the user prompt
          inv  lstrcat, addr buffer, offset FileName    ; Add filename to the user prompt
          mov  ax, '?'                                  ; End it with a question mark
          mov  word ptr buffer1, ax                     ; Store it
          inv  lstrcat, addr buffer, addr buffer1       ; Combine buffers
          inv  MessageBox, hWnd, addr buffer, offset AppName, MB_YESNOCANCEL or MB_ICONQUESTION ; Beg the question
          .if eax==IDYES                ; If the user says 'Yes' ...
            inv  SaveEdit               ; Save the file
          .elseif eax==IDNO             ; If the user says 'No'
            mov  eax, FALSE             ; Set Errorlevel
          .else                         ; else ...
            mov  eax, TRUE              ; Set Errorlevel
          .endif                        ; End of conditional
        .endif                          ; End of conditional
        ret                             ; Return
;---------------------------------------;
WantToSave  endp
;
;
LoadFile    proc    lpFileName:DWORD
;---------------------------------------;
        LOCAL   hFile:DWORD             ; Handle of curremt document
        LOCAL   editstream:EDITSTREAM   ; Contains information about a data stream used with a rich edit control
        LOCAL   chrg:CHARRANGE          ; Structure
;
;       Open the file
        inv  CreateFile, lpFileName, GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, 0   ; Create the file
        .if eax!=INVALID_HANDLE_VALUE   ; If handle is valid ...
          mov  hFile, eax               ; Save it
          inv  lstrcpy, offset FileName, lpFileName ; Copy buffer to FileName
;         Stream the text into the richedit control
          push hFile                    ; Save handle
          pop  editstream.dwCookie      ; Retrieve handle into the structure
          mov  editstream.pfnCallback, offset StreamInProc  ; Store address of 'get data' routine in structure
          inv  SendMessage, hREd, EM_STREAMIN, SF_TEXT, addr editstream ; Load the file
          inv  CloseHandle, hFile       ; Close the file
          inv  SendMessage, hREd, EM_SETMODIFY, FALSE, 0    ; Set 'file modified' flag to 0
          mov  chrg.cpMin, 0             ; File start = 0
          mov  chrg.cpMax, 0             ; File ends  = 0
          inv  SendMessage, hREd, EM_EXSETSEL, 0, addr chrg ; Select all of the text in the control
          inv  SetWinCaption            ; Display the Window's Caption
          mov  eax, FALSE               ; Set errorlevel [to 'no errors'
          inv  AppendToMenu             ; Add filename and path to the MRU
        .else                           ; If handle is invalid
          inv  MessageBox, hWnd, offset OpenFileFail, offset AppName, MB_OK or MB_ICONERROR ; Display error message
          mov  eax, TRUE                ; Set errorlevel
        .endif                          ; End of conditional
        ret                             ; Bye
;---------------------------------------;
LoadFile    endp
;
;
OpenEdit    proc    USES ESI EDI
;---------------------------------------;
        LOCAL   ofn:OPENFILENAME        ; Structure
        LOCAL   buffer[MAX_PATH]:BYTE   ; Temporary buffer
;
        inv  RtlZeroMemory, addr ofn, sizeof ofn    ; Zero out the ofn structure
;       Setup the ofn struct
        mov  ofn.lStructSize, sizeof ofn    ; Store the size of the structure
        push hWnd                       ; Save window handle
        pop  ofn.hwndOwner              ; Retrieve it into the structure
        push hInstance                  ; Save instance of this application
        pop  ofn.hInstance              ; Retrieve it into the structure
        mov  ofn.lpstrFilter, NULL      ; Clear the filter mask
        mov  buffer[0], 0               ; Clear the buffer
        lea  eax, buffer                ; Get location of the temporary buffer
        mov  ofn.lpstrFile, eax         ; Store it in the structure
        mov  ofn.nMaxFile, sizeof buffer    ; Store the size of the buffer
        mov  ofn.lpstrDefExt, NULL      ; No default extension
        mov  ofn.Flags, OFN_FILEMUSTEXIST or OFN_HIDEREADONLY or OFN_PATHMUSTEXIST  ; Set attribute masks
        inv  GetOpenFileName, addr ofn  ; Show the Open dialog
        .if eax                         ; If filename is valid ...
          inv  LoadFile, addr buffer    ; Load the file
          inv  lstrcpy, Offset PathName, Addr buffer
          inv  lstrlen, Addr buffer     ; Get length of fully qualified path and filename
          lea  edi, buffer              ; Point to start of path
          add  edi, eax                 ; Now at end of path
          sub  edi, 4                   ; Move to extension start
          mov  ecx, 4                   ; 4 characters to transfer
          lea  esi, ExtType             ; Destination
again:    mov  al, [edi]                ; Get character
          mov  [esi], al                ; Put character
          inc  esi                      ; update position
          inc  edi                      ; update position
          loop again                    ; Copy four characters
          inv  ShowTools                ; Update the available Menu Options
          mov  Modified, 0              ; Set file to 'not modified'
          mov  Flag, 0                  ; Clear the Caption flag
          inv  lstrcpy, offset PathName, addr buffer    ; Get filename
          inv  SetWinCaption            ; Add it to the caption
        .endif                          ; End of conditional
        ret                             ; Return
;---------------------------------------;
OpenEdit    endp
;
;
; ______________________________________
;|                                      |
;| The Find Procedure uses:             |
;|      FR_DOWN         equ 00000001h   |
;|                                      |
;| The FindDlgProc Procedure uses:      |
;|      FR_DOWN         equ 00000001h   |
;|      FR_WHOLEWORD    equ 00000002h   |
;|      FR_MATCHCASE    equ 00000004h   |
;|______________________________________|
;|                                      |
;| These three constant type equates    |
;| are declared in the windows.inc file |
;| and are used as flag values by these |
;| two procedures to control search     |
;| parameters.  They operate on the bit |
;| level and strings are tested using   |
;| the AND instruction.                 |
;|                                      |
;|                        Editor's Note |
;|______________________________________|
;
Find    proc    frType:DWORD
;---------------------------------------;
        inv  SendMessage, hREd, EM_EXGETSEL, 0, offset ft.chrg  ; Get current selection
;       Setup find parameters in case of previous pass
        mov  eax, fr                    ; Get direction flag
        and eax, FR_DOWN                ; Test if direction is 'down'
        .if eax                         ; If yes ...
          .if fres!=-1                  ; 'Resume' Flag
            inc  ft.chrg.cpMin          ; Update the buffer pointer
          .endif                        ; End of conditional
          mov  ft.chrg.cpMax, -1        ; End of text in the control
        .else                           ; Else
          mov  ft.chrg.cpMax, 0         ; 0 means control is empty
        .endif                          ; End of conditional
        mov  ft.lpstrText, offset findbuff  ; Store address of text to find in the structure
Loop1:  inv  SendMessage, hREd, EM_FINDTEXTEX, frType, offset ft    ; Do the find
        mov  fres, eax                  ; 'Resume' Flag
        .if eax!=-1                     ; If the search was successful ...
          inv  SendMessage, hREd, EM_EXSETSEL, 0, offset ft.chrgText    ; Mark the found text
        .else                           ; Or ...
          mov  eax, fr                  ; Get Find/Replace flags
          and  eax, FR_DOWN             ; Test the direction of the search
          .if eax                       ; If searching backward ...
            inv  lstrcpyn, offset TopBot, offset Top, 6 ; ADD the proper string to the message
          .else                         ; If searching forward...
            inv  lstrcpyn, offset TopBot, offset Bot, 6 ; ADD the proper string to the message
          .endif                        ; End of conditional
          inv  MessageBox, NULL, offset FindEnd, offset szFR, MB_YESNO or\
               MB_ICONQUESTION or MB_TASKMODAL  ; Display the message prompt
          cmp  eax, IDNO                ; If 'Restart=no'
          je   Done                     ; Return to main Message loop
          mov  eax, fr                  ; Get Find/Replace flags
          and  eax, FR_DOWN             ; Test the direction of the search
          .if eax                       ; If searching backward ...
            inv  SendMessage, hREd, EM_SETSEL, 0, 0 ; Get selected text
            mov  ft.chrg.cpMin, 0       ; Start position
            mov  ft.chrg.cpMax, -1      ; End position
          .else                         ; If searching forward ...
            inv  SendMessage, hREd, WM_GETTEXTLENGTH, 0, 0  ; Get text length
            mov  ft.chrg.cpMin, eax     ; Store it as current position
            mov  ft.chrg.cpMax, 0       ; Clear max position
          .endif                        ; End of conditional
          jmp  Loop1                    ; Go search again
        .endif                          ; End of conditional
Done:   ret                             ; Return
;---------------------------------------;
Find    endp
;
;
FindDlgProc proc    hWin:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
;---------------------------------------;
        LOCAL   hCtl:DWORD              ; Temporary handle storage
;
        mov  eax, uMsg                  ; Get message
        .if eax==WM_INITDIALOG          ; Initialize
          mov  eax, hWin                ; Get handle of the window
          mov  hFind, eax               ; Save it
          .if lParam                    ; If there is a Message in the queue
            mov  eax, BN_CLICKED        ; Get 'Button clicked' value
            shl  eax, 16                ; Just the LSWord is used
            or   eax, IDC_BTN_REPLACE   ; Test if it was the 'Replace' Button
            inv  PostMessage, hWin, WM_COMMAND, eax, 0  ; Send the result as a 'message'
          .endif                        ; End of conditional
;         Put the text into the edit boxes
          inv  SendDlgItemMessage, hWin, IDC_FINDTEXT, EM_LIMITTEXT, 255, 0 ; Set maximum text size
          inv  SendDlgItemMessage, hWin, IDC_FINDTEXT, WM_SETTEXT, 0, offset findbuff   ; Insert text to find
          inv  SendDlgItemMessage, hWin, IDC_REPLACETEXT, EM_LIMITTEXT, 255, 0  ; Set maximum text size
          inv  SendDlgItemMessage, hWin, IDC_REPLACETEXT, WM_SETTEXT, 0, offset replacebuff ; Insert text to replace
;         Set check boxes
          mov  eax, fr                  ; Get flags
          and  eax, FR_MATCHCASE        ; Test if 'Match Case' is set
          .if eax                       ; If it is ...
            inv  CheckDlgButton, hWin, IDC_CHK_MATCHCASE, BST_CHECKED   ; Check the box
          .endif                        ; End of conditional
          mov  eax, fr                  ; Get flags
          and  eax, FR_WHOLEWORD        ; Test if 'Whole Word' is set
          .if eax                       ; If it is ...
            inv  CheckDlgButton, hWin, IDC_CHK_WHOLEWORD, BST_CHECKED   ; Check the box
          .endif                        ; End of conditional
;         Set find direction
          mov  eax, fr                  ; Get flags
          and  eax, FR_DOWN             ; Test if 'Search Down' is set
          .if eax                       ; If it is ...
            mov  eax, IDC_RBN_DOWN      ; Set the direction to 'Down'
          .else                         ; Else
            mov  eax, IDC_RBN_UP        ; Set the direction to 'Up'
          .endif                        ; End of conditional
          inv  CheckDlgButton, hWin, eax, BST_CHECKED   ; Check the appropriate button
        .elseif eax==WM_COMMAND         ; Command (message) waiting to be processed?
          mov  eax, wParam              ; Get message
          mov  edx, eax                 ; Store it in the data register
          shr  edx, 16                  ; Preserve only the LSWord
          and  eax, 0FFFFh              ; Mask out the unused portions
          .if edx==BN_CLICKED           ; If a button was clicked ...
            .if eax==IDOK               ; If it was the 'OK' button
              inv  Find, fr             ; Find the text
            .elseif eax==IDCANCEL       ; If it was the 'Cancel' button
              inv  SendMessage, hWin, WM_CLOSE, NULL, NULL  ; Close the find dialog box
            .elseif eax==IDC_BTN_REPLACE    ; If it was the 'Replace' button
              inv  GetDlgItem, hWin, IDC_BTN_REPLACEALL ; Get button handle
              mov  hCtl, eax            ; Save it
              inv  IsWindowEnabled, hCtl    ; Is it enabled?
              .if !eax                      ; If not ...
                inv  EnableWindow, hCtl, TRUE   ; Enable 'Replace all' button
                inv  SetWindowText, hWin, offset Replace    ; Set caption to Replace
                inv  GetDlgItem, hWin, IDC_REPLACESTATIC    ; Get handle to the 'Replace' button
                inv  ShowWindow, eax, SW_SHOWNA             ; Show Replace button
                inv  GetDlgItem, hWin, IDC_REPLACETEXT      ; Get handle of the 'Replace' text box
                inv  ShowWindow, eax, SW_SHOWNA             ; Show the edit control
              .else                     ; Or
                .if fres!=-1            ; If 'Resume' Flag is set
                  inv  SendMessage, hREd, EM_EXGETSEL, 0, offset ft.chrg    ; Get location of text to be replaced
                  inv  SendMessage, hREd, EM_REPLACESEL, TRUE, offset replacebuff   ; Replace the text
                  add  HowMany, 1       ; Count the transaction
;                  _________________________________________________________________
;                 |                                                                 |
;                 | The value will be converted to decimal from hex and shown in    |
;                 | the Status Bar's 3rd quadrant.  The 3rd quadrant is referred to |
;                 | logically as quadrant number 2 because number 1 is logically 0. |
;                 |_________________________________________________________________|
;
                  mov  ShowMessage[0], 0          ; Clears the buffer used for counting
                  inv  GetDlgItem, hWnd, IDC_SBR  ; Get handle of the Statusbar
                  mov  hCtl, eax                  ; Save handle of the Statusbar
                  inv  szCatStr, ADDR ShowMessage, ADDR CMessagePrefix  ; Write the string into the ShowMessage buffer
                  inv  dwtoa, HowMany, ADDR HowManyASCIIZ   ; Convert the count value to ASCIIZ
                  inv  szCatStr, ADDR ShowMessage, ADDR HowManyASCIIZ   ; ADD ASCIIZ info to the ShowMessage buffer
                  inv  szCatStr, ADDR ShowMessage, ADDR CMessageSuffix  ; Write the string into the ShowMessage buffer
                  inv  SendMessage, hCtl, SB_SETTEXT, 2, addr ShowMessage  ; Display the current count
                  inv  lstrlen, offset replacebuff  ; Get length of string in the buffer
                  add  eax, ft.chrg.cpMin   ; Plus offset from document start
                  mov  ft.chrg.cpMax, eax   ; Store it as the end point of the selection
                  inv  SendMessage, hREd,EM_EXSETSEL,0,offset ft.chrg   ; Reselect the text
                .endif                  ; End of conditional
                inv  Find, fr           ; Find text, again
              .endif                    ; End of conditional
            .elseif eax==IDC_BTN_REPLACEALL ; If it was the 'Replace All' button
              .if fres==-1              ; If 'Resume' Flag is set
                inv  Find, fr           ; Find text, again
              .endif                    ; End of conditional
              .while fres!=-1           ; If 'Resume' Flag is set
                mov  eax, BN_CLICKED    ; Get 'Button Clicked' flag
                shl  eax, 16            ; Only want the LSWord
                or   eax, IDC_BTN_REPLACE   ; Test for the 'Replace' button
                inv  SendMessage, hWin, WM_COMMAND, eax, 0  ; Pass the result on as a message
              .endw                     ; End of conditional
            .elseif eax==IDC_RBN_DOWN   ; Search Down?
              or   fr, FR_DOWN          ; Set find direction to Down
              mov  fres, -1             ; Set the 'Resume' Flag
            .elseif eax==IDC_RBN_UP     ; Search Up?
              and  fr, -1 xor FR_DOWN   ; Set find direction to up
              mov  fres, -1             ; Set the 'Resume' Flag
            .elseif eax==IDC_CHK_MATCHCASE  ; Match Case?
              inv  IsDlgButtonChecked, hWin, IDC_CHK_MATCHCASE  ; Set Match Case mode
              .if eax                   ; If yes ...
                or   fr, FR_MATCHCASE   ; Set the flag
              .else                     ; Else
                and  fr, -1 xor FR_MATCHCASE    ; Reset the flag
              .endif                    ; End of conditional
              mov  fres, -1             ; Set the 'Resume' Flag
            .elseif eax==IDC_CHK_WHOLEWORD  ; Whole Word?
              inv  IsDlgButtonChecked, hWin, IDC_CHK_WHOLEWORD  ; Set whole word mode
              .if eax                   ; If yes ...
                or   fr, FR_WHOLEWORD   ; Set the flag
              .else                     ; Else
                and  fr, -1 xor FR_WHOLEWORD    ; Reset the flag
              .endif                    ; End of conditional
              mov  fres, -1             ; Set the 'Resume' flag
            .endif                      ; End of conditional
          .elseif edx==EN_CHANGE        ; This message is sent when the user has taken an action that may have altered text in an edit control.
            ; Update text buffers
            .if eax==IDC_FINDTEXT       ; Request To Find Text?
              inv  SendDlgItemMessage, hWin, eax, WM_GETTEXT, sizeof findbuff, offset findbuff
              mov  fres, -1             ; Set the 'Resume' Flag
            .elseif eax==IDC_REPLACETEXT    ; Request To Replace Text?
              inv  SendDlgItemMessage, hWin, eax, WM_GETTEXT, sizeof replacebuff, offset replacebuff
              mov  fres, -1             ; Set the 'Resume' Flag
            .endif                      ; End of conditional
          .endif                        ; End of conditional
        .elseif eax==WM_ACTIVATE        ; This message is sent when a window is being activated or deactivated.
          mov  fres, -1                 ; Set the 'Resume' Flag
        .elseif eax==WM_CLOSE           ; Close Request?
;          _________________________________________________________________
;         |                                                                 |
;         | The value will be converted to decimal from hex and shown in    |
;         | the Status Bar's 3rd quadrant.  The 3rd quadrant is referred to |
;         | logically as quadrant number 2 because number 1 is logically 0. |
;         |_________________________________________________________________|
;
          mov  ShowMessage[0], 0        ; Clears the the buffer used for counting
          xor  eax, eax                 ; Prepare to zero the counter for possible recycling
          mov  HowMany, eax             ; Do it
          inv  GetDlgItem, hWnd, IDC_SBR    ; Get handle of the Statusbar
          mov  hCtl, eax                ; Save handle of the Statusbar
          mov  hFind, 0                 ; Clear the dialog box handle
          inv  DestroyWindow, hWin      ; Close the dialog box
          mov  ShowMessage[0], 0        ; Clears the the buffer used for counting
          xor  eax, eax                 ; Prepare to zero the counter for possible recycling
          mov  HowMany, eax             ; Do it
          inv  GetDlgItem, hWnd, IDC_SBR    ; Get handle of the Statusbar
          mov  hCtl, eax                    ; Save handle of the Statusbar
          inv  SendMessage, hCtl, SB_SETTEXT, 2, addr ShowMessage   ; Clear the Display
          inv  SetFocus, hREd           ; Set focus to the edit control
        .else                           ; Else
          mov  eax, FALSE               ; Set Errorlevel
          ret                           ; Return
        .endif                          ; End of conditional
        mov  eax, TRUE                  ; Set Errorlevel
        ret                             ; Return
;---------------------------------------;
FindDlgProc endp
;
;
DoToolBar   proc    hInst:DWORD,hToolBar:HWND
;---------------------------------------;
        LOCAL   tbab:TBADDBITMAP        ; Bitmap that contains the toolbar button images
;
;       Set toolbar struct size
        inv  SendMessage, hToolBar, TB_BUTTONSTRUCTSIZE, sizeof TBBUTTON, 0 ; Store maximum size
;       Set toolbar bitmap
        push hInst                      ; Save instance of this application
        pop  tbab.hInst                ; Store it in the structure
        mov  tbab.nID, IDB_TBRBMP       ; Store bitmap in the structure
        inv  SendMessage, hToolBar, TB_ADDBITMAP, 15, addr tbab ; Make the toolbar
;       Set toolbar buttons
        inv  SendMessage, hToolBar, TB_ADDBUTTONS, ntbrbtns, offset tbrbtns ; Add the buttons
        mov  eax, hToolBar              ; Get the toolbar handle (used as the return code)
        ret                             ; Return
;---------------------------------------;
DoToolBar   endp
;
;
SetFormat   proc    hWin:DWORD
;---------------------------------------;
        LOCAL   chrg1:CHARRANGE         ; Structure
        LOCAL   chrg2:CHARRANGE         ; Structure
        LOCAL   pf:PARAFORMAT2          ; Structure
        LOCAL   cf:CHARFORMAT           ; Structure
        LOCAL   tp:DWORD                ; Scratch variable
        LOCAL   buffer[16]:BYTE         ; Temporary buffer
        LOCAL   pt:POINT                ; Pixel point
        LOCAL   hDC:HDC                 ; Device context
;
;       Save modification state
        inv  SendMessage, hWin, EM_GETMODIFY, 0, 0  ; Get document state
        push eax                        ; Save it
;       Save selection
        inv  SendMessage, hWin, EM_EXGETSEL, 0, addr chrg1  ; Get range of possible selection
        inv  SendMessage, hWin, EM_HIDESELECTION, TRUE, 0   ; Save it by hiding it
;       Select all text
        mov  chrg2.cpMin, 0             ; Get start of document
        mov  chrg2.cpMax, -1            ; Get end of document
        inv  SendMessage, hWin, EM_EXSETSEL, 0, addr chrg2  ; Select all of the text in the control
;       Set font charset
        mov  cf.cbSize, sizeof cf       ; Get size of the structure
        mov  cf.dwMask, CFM_CHARSET or CFM_FACE or CFM_SIZE or CFM_COLOR    ; Set the attribute mask
        mov  al, lfnt.lfCharSet         ; Get current character set
        mov  cf.bCharSet, al            ; Store it in the structure
        mov  al, lfnt.lfPitchAndFamily  ; Get character styles
        mov  cf.bPitchAndFamily, al     ; Store it in the structure

        inv  lstrcpyn, addr cf.szFaceName, offset lfnt.lfFaceName, LF_FACESIZE
        mov  eax, lfnt.lfHeight         ; Get height
        neg  eax                        ; Multiply by -1
        mov  ecx, 15                    ; Get multiplier
        mul  ecx                        ; Multiply by 15
        mov  cf.yHeight, eax            ; Save the result
        mov  eax, rgb                   ; Get foreground color
        mov  cf.crTextColor, eax        ; Save it
        inv  SendMessage, hWin, EM_SETCHARFORMAT, SCF_SELECTION, addr cf    ; Set character format
;       Get tab width
        inv  GetDC, hWin                ; Retrieves a handle of a device context (DC) for the edit control
        mov  hDC, eax                   ; Save the DC
        inv  SelectObject, hDC, hFont   ; Selects an object into the specified device context
        push eax                        ; Save it
        mov  eax, 'WWWW'                ; Get 4 of the largest character in the set
        mov  dword ptr buffer, eax      ; Put it in the buffer
        inv  GetTextExtentPoint32, hDC, addr buffer, 4, addr pt ; Computes the width and height of the specified string of text
        pop  eax                        ; Restore the font
        inv  SelectObject, hDC, eax     ; Reset the device context
        inv  ReleaseDC, hWin, hDC       ; Release the device context resources
        mov  eax, pt .x                  ; Save the x coordinate (size)
        mov  ecx, TabSize               ; Get current tabsize
        mul  ecx                        ; Get pixel value
        mov  ecx, 15                    ; Get multiplier
        mul  ecx                        ; Multiply by 15
        shr  eax, 2                     ; Divide by 2
        mov  tp, eax                    ; Save the resulting tab points (in pixels)
;       Set tab stops
        mov  pf.cbSize, sizeof pf       ; Get size of the structure
        mov  pf.dwMask, PFM_TABSTOPS    ; Set mask
        mov  pf.cTabCount, MAX_TAB_STOPS    ; Set tab count
        xor  eax, eax                   ; Clear the accumulator
        xor  edx, edx                   ; Clear the data register
        mov  ecx, MAX_TAB_STOPS         ; Get tab count
Again:  add  eax, tp                    ; Plus pixel count
        mov  dword ptr pf.rgxTabs[edx], eax ; Store tab stop in the structure
        add  edx, 4                     ; Get next tab stop
        loop Again                      ; Build complete tab stop table
        inv  SendMessage, hWin, EM_SETPARAFORMAT, 0, addr pf    ; Store this information in the edit control
;       Restore modify state
        pop  eax                        ; Restore the document state
        inv  SendMessage, hWin, EM_SETMODIFY, eax, 0    ; Reset the edit control to how it was originally
;       Restore selection
        inv  SendMessage, hWin, EM_EXSETSEL, 0, addr chrg1  ; Get positions of any text that was selected
        inv  SendMessage, hWin, EM_HIDESELECTION, FALSE, 0  ; Make it visible
        ret                             ; Return
;---------------------------------------;
SetFormat   endp
;
;
WordWrap    proc
;---------------------------------------;
        .if WWrap==0                    ; If wordwrap is off
          inv  CheckMenuItem, hMenu, IDM_WWRAP, MF_UNCHECKED    ; Clear the check mark
          push 1                        ; Save new setting
        .else                           ; or...
          inv  CheckMenuItem, hMenu, IDM_WWRAP, MF_CHECKED      ; Set the check mark
          push 0                        ; Save new setting
        .endif                          ; End of conditional
        pop  WWrap                      ; Get WWrap setting
;       If WWrap=0, then no wrap.  If WWrap=1 then wrap occurs at the end of the last
;       word that will fit the control's current width
        inv  SendMessage, hREd, EM_SETTARGETDEVICE, 0, WWrap    ; Set line width method
        ret                                                     ; Return  to caller
;---------------------------------------
WordWrap    endp
;
;
ShowPosition    proc
;---------------------------------------;
        LOCAL   hCtl:HWND               ; Handle storage used by different controls
;
        inv  SendMessage, hREd, EM_LINEINDEX, -1, 0     ; Offset to start of current line from beginning of file
        mov  FileOff, eax               ; Save the offset
        inv  SendMessage, hREd, EM_EXLINEFROMCHAR, 0, FileOff   ; Get row value (zero based)
        mov  BinRow, eax                ; Current Row - 1
        inc  BinRow                     ; Current Row
        inv  SendMessage, hREd, EM_LINEINDEX, BinRow, 0 ; Get offset to start of next row from beginning of file
        .if eax == -1                   ; -1 if past EOF
          mov  eax, 1                   ; If so, then make it a 1
        .endif                          ; End of conditional
        mov  BinColumnTotal, eax        ; Offset to start of next line from beginning of file
        inv  SendMessage, hREd, EM_GETLINECOUNT, 0, 0           ; Get total amount of lines in the control
        mov  BinRowTotal, eax           ; Total amount of lines in editor
;        _______________________________________________________________
;       |                                                               |
;       | Get start and end positions of current selection, if no text  |
;       | is selected in the control, both values will be the same.     |
;       | You can probably see this would also be very useful because   |
;       | it is a slick way of getting the control to reveal what the   |
;       | position of the insertion point within the text control.      |
;       |_______________________________________________________________|
;
        inv  SendMessage, hREd, EM_GETSEL, offset BinColumn, offset BinColOffset
        push BinColOffset               ; Save position within the line
        push FileOff                    ; Save position of line start - 1
        pop  eax                        ; Now in eax register
        pop  BinColumn                  ; Get position within the line
        sub  BinColumn, eax             ; Get column position - 1
        inc  BinColumn                  ; Current Column
        .if BinColumnTotal == 1         ; If current line is last line...
          mov  eax, BinColumn           ; Then get Column
          mov  BinColumnTotal, eax      ; and Make it the max value
        .else                           ; Else
          push FileOff                  ; Save position of line start - 1
          pop  eax                      ; Now in eax
          sub  BinColumnTotal, eax      ; Get column position
        .endif                          ; End of conditional
;        _________________________________________________________________
;       |                                                                 |
;       | The value will be converted to decimal from hex and shown in    |
;       | the Status Bar's 3rd quadrant.  The 3rd quadrant is referred to |
;       | logically as quadrant number 2 because number 1 is logically 0. |
;       |_________________________________________________________________|
;
        mov  ShowRow[0], 0              ; Clears the the buffer
        inv  GetDlgItem, hWnd, IDC_SBR  ; Get handle of the Statusbar
        mov  hCtl, eax                  ; Save handle of the Statusbar
        inv  szCatStr, ADDR ShowRow, ADDR RowMsg    ; Write the string into the ShowRow message
        inv  dwtoa, BinRow, ADDR Row    ; Convert double word Row value to ASCII
        inv  szCatStr, ADDR ShowRow, ADDR Row       ; ADD Row to the ShowRow buffer
        inv  szCatStr, ADDR ShowRow, ADDR OfMsg     ; ADD ' of ' message to the ShowRow message
        inv  dwtoa, BinRowTotal, ADDR RowTotal      ; Convert double word Total Row value to ASCII
        inv  szCatStr, ADDR ShowRow, ADDR RowTotal  ; Add RowTotal to ShowRow message
        mov  ShowColumn[0], 0           ; Clears the the buffer
        inv  szCatStr, ADDR ShowColumn, ADDR ColumnMsg  ; Write the string into the ShowColumn message
        inv  dwtoa, BinColumn, ADDR Column          ; Convert double word Column value to ASCII
        inv  szCatStr, ADDR ShowColumn, ADDR Column ; ADD Column to the ShowColumn buffer
        inv  szCatStr, ADDR ShowColumn, ADDR OfMsg  ; ADD ' of ' message to the ShowColumn message
        inv  dwtoa, BinColumnTotal, ADDR ColumnTotal        ; Convert double word Total Column value to ASCII
        inv  szCatStr, ADDR ShowColumn, ADDR ColumnTotal    ; Add ColumnTotal to ShowColumn message
        inv  SendMessage, hCtl, SB_SETTEXT, 0, addr ShowRow     ; Display the message in the status bar
        inv  SendMessage, hCtl, SB_SETTEXT, 1, addr ShowColumn  ; Display the message in the status bar
        ret                             ; Return  to caller
;---------------------------------------;
ShowPosition endp
;
;
; ______________________________________
;|                                      |
;| Display messages in the statusbar.   |
;| Our target is the fourth quadrant    |
;| The message will change every minute |
;|______________________________________|
;
QFour   proc    USES ESI EDI
;---------------------------------------;
        LOCAL   hCtl:HWND               ; Handle to the Statusbar will be stored here
;
        inv  GetDlgItem, hWnd, IDC_SBR  ; Get handle of the Statusbar
        mov  hCtl, eax                  ; Save handle of the Statusbar
        mov  eax, fView                 ; Get Toolbar/Statusbar Flag bits
        and  eax, 2                     ; Test the Statusbar bit
        .if eax                         ; Is Statusbar hidden
          jmp  done                     ; Leave if it is
        .endif                          ; End of conditional
        push offset sTime               ; Get the local ...
        call GetLocalTime               ; time from Windows
        .if Counter == 0                ; Initial run?
          MOVmw Minute, sTime.wMinute   ; Get Current minute value
          inv  SendMessage, hCtl, SB_SETTEXT, 3, addr Message4  ; Display the message
          inc  Counter                  ; Sync the counter
          ret                           ; Return  to caller
        .endif                          ; End of conditional
        push Minute                     ; Put current minute on the stack
        pop  eax                        ; Get current minute
        cmp  ax, sTime.wMinute          ; Has it changed?
        je   done                       ; Show message for 1 minute
        MOVmw Minute, sTime.wMinute     ; Update the current minute value
        inc  Counter                    ; Move to the next message
        .if Counter == 4                ; End Of Messages?
          mov  byte ptr Counter, 1      ; Rollback to first message, endlessly repeating
        .endif                          ; End of conditional
        .if Counter == 1                ; Show appropriate message
          inv  SendMessage, hCtl, SB_SETTEXT, 3, addr Message4  ; Display the message
        .elseif Counter == 2            ; Show appropriate message
          .if Modified == 1             ; If document is modified...
            inv  SendMessage, hCtl, SB_SETTEXT, 3, addr Message2    ; Display the message
          .else                         ; Next conditional
            inv  SendMessage, hCtl, SB_SETTEXT, 3, addr Message3    ; Display the message
          .endif                        ; End of conditional
        .elseif Counter == 3            ; Show appropriate message
          inv  SendMessage, hCtl, SB_SETTEXT, 3, addr Message1  ; Display the message
        .endif                          ; End of conditional
done:   ret                             ; Return  to caller
;---------------------------------------;
QFour   endp
;
;
ShowFont proc
; ______________________________________
;|                                      |
;| Build the complete FontName and size |
;| and display it in the status bar.    |
;|______________________________________|
;
        inv  RtlZeroMemory, addr Stuffing, sizeof Stuffing  ; Clear the structure variables
        mov  eax, PointSize             ; Get point size
        div  DecValue                   ; Divide by 10
        inv  dwtoa, eax, ADDR ASCIIPointSize    ; Convert it to ASCII
        inv  lstrcpy, ADDR Stuffing, ADDR FontName  ; Build the message
        inv  lstrcat, ADDR Stuffing, ADDR Delimit   ; Build the message
        inv  lstrcat, ADDR Stuffing, ADDR ASCIIPointSize    ; Build the message
        inv  lstrcat, ADDR Stuffing, ADDR EndOfString   ; Finish building the message
        mov  byte ptr Counter, 0        ; Force a status bar update
        ret                             ; Return  to caller
;---------------------------------------
ShowFont endp
;
;
SetColor   proc
;---------------------------------------;
        LOCAL Chg:DWORD                 ; Scratch variable
;
        inv  SendMessage, hREd, EM_GETMODIFY, 0, 0  ; Has the edit control been modified
        mov  Chg, eax                   ; Save the state of the document
        inv  RtlZeroMemory, addr cc, sizeof cc      ; Zero out the structure
        mov  charF.cbSize, sizeof charF ; Store size of structure
        inv  SendMessage, hREd, EM_GETCHARFORMAT, TRUE, addr charF  ; Get the current character format
        and  charF.dwEffects, 0fffffffh ; Turn off AutoColor
;       Set the CHOOSECOLOR attributes
        mov  cc.lStructSize, sizeof cc  ; Store size of structure
        mov  eax, hWnd                  ; Get handle of 'owner'
        mov  cc.hwndOwner, eax          ; Save it
        mov  eax, hInstance             ; Get handle of this instance
        mov  cc.hInstance, eax          ; Save it
        .if SetBgColor != 1             ; If setting Text Color...
          mov  eax, charF.crTextColor   ; Get current text color
        .else                           ; or if setting Background Color...
          mov  eax, charF.crBackColor   ; Get current background color
        .endif                          ; End of conditional
        mov  cc.rgbResult, eax          ; Store the color in  the structure
        mov  cc.lpCustColors, offset CustClrs   ; Get offset to custom colors
        mov  cc.Flags, CC_FULLOPEN or CC_RGBINIT    ; Set the flags
        .if FirstRun==0                 ; 0=Normal, 1=First Run
          inv  ChooseColor, addr cc     ; Show the SetColor Dialog Box
          cmp  eax, FALSE               ; Cancelled or error occurred?
          je   ColorRet                 ; Jump if error or cancelled
        .else                           ; Or...
          mov  eax, BgColor             ; Get BackGround Color
          mov  charF.crBackColor, eax   ; Save it for future use
          mov  eax, rgb                 ; Get ForeGround Color
          mov  cc.rgbResult, eax        ; Fudge it as the selected color
        .endif                          ; End of conditional
        mov  eax, cc.rgbResult          ; Get selected color
        .if SetBgColor != 1             ; 0=ForeGround, 1=BackGround
          mov  charF.crTextColor, eax   ; Store the new color
          mov  rgb, eax                 ; Store it in preparation for a registry write
        .else                           ; Or...
          mov  charF.crBackColor, eax   ; Store the new color
          mov  BgColor, eax             ; Save the new background color
          inv  SendMessage, hREd, EM_SETBKGNDCOLOR, 0, eax  ; Set Background Color
          inv  SendMessage, hREd, EM_SETCHARFORMAT, SCF_ALL, addr charF ; Apply to all
        .endif                          ; End of conditional
        inv  SendMessage, hREd, EM_SETCHARFORMAT, SCF_ALL, addr charF   ; Set the character format
ColorRet:
        inv  SendMessage, hREd, EM_SETMODIFY, Chg, 0  ; Restore previous document state
        ret                             ; Return  to caller
;---------------------------------------;
SetColor   endp
;
;
ChangeCase  proc    USES EDI
;---------------------------------------
        inv  SendMessage, hREd, EM_EXGETSEL, 0, offset cr   ; Get start and ending positions of highlighted text
        mov  eax, cr.cpMax              ; Get end position
        sub  eax, cr.cpMin              ; Minus the start position
        .if eax < 255                   ; If in range...
          inv  SendMessage, hREd, EM_GETSELTEXT, 0, addr szFlipCase     ; Get selected text
        .endif                          ; End of conditional
        push edi                        ; Register preservation
        mov  edi, offset szFlipCase     ; Pointer to text selection storage buffer
Again:  mov  al, [edi]                  ; Get a character
        .if Flag == 3                   ; Invert selected text
          .if al >= 'A' && al <= 'Z'    ; If upper case...
            or   byte ptr [edi], 20h    ; Convert it to lower case
          .elseif al >= 'a' && al <= 'z'  ; If lower case...
            and  byte ptr [edi], 5Fh    ; Convert it to upper case
          .endif                        ; End of conditional
        .elseif Flag == 2               ; Convert selected text to lower case
          .if al >= 'a' && al <= 'z'    ; If lower case...
            and  byte ptr [edi], 5Fh    ; Convert it to upper case
          .endif                        ; End of conditional
        .elseif Flag == 1               ; Convert selected text to upper case
          .if al >= 'A' && al <= 'Z'    ; If upper case...
            or   byte ptr [edi], 20h    ; Convert it to lower case
          .endif                        ; End of conditional
        .endif                          ; End of conditional
        inc  edi                        ; Update the buffer pointer
        or   al, al                     ; Done?
        jne  Again                      ; Continue until ASCIIZ is reached
        pop  edi                        ; Restore the register
;       Put back the reconditioned text
        inv  SendMessage, hREd, EM_REPLACESEL, TRUE, addr szFlipCase
        ret                             ; Return to caller
;---------------------------------------
ChangeCase  endp
;
;
; ______________________________________
;|                                      |
;| Enable or disable the items in the   |
;| Edit Menu and Toolbar.               |
;|______________________________________|
;
EnableDisable   proc
;---------------------------------------;
        LOCAL   hCtl:HWND               ; Handle storage used by different controls
        LOCAL   TWord1:DWORD            ; Scratch variable
        LOCAL   TWord2:DWORD            ; Scratch variable
;
        inv  GetDlgItem, hWnd, IDC_TBR  ; Get handle of the toolbar control
        mov  hCtl, eax                  ; Save the handle
        mov  TWord2, TRUE               ; Set 'true' condition (as default)
        inv  SendMessage, hREd, EM_CANUNDO, 0, 0    ; Test if 'can undo' is viable'
        cmp  eax, TRUE                  ; Anything to undo?
        jne  EdMu1                      ; Jump if no
        mov  TWord1, MF_ENABLED         ; Set 'true' condition
        jmp  EdMu2                      ; Go modify the menu and toolbar
EdMu1:  mov  TWord1, MF_GRAYED          ; Set 'false' condition
        mov  TWord2, FALSE              ; Set 'false' condition
EdMu2:  inv  EnableMenuItem, hMenu, 10101, TWord1               ; Undo Menu Selection
        inv  SendMessage, hCtl, TB_ENABLEBUTTON, 10101, TWord2  ; Undo Button
        inv  SendMessage, hREd, EM_CANREDO, 0, 0    ; Test if the 'undo' function was used?
        cmp  eax, TRUE                  ; Anything to redo?
        jne  EdMu3                      ; Jump if no
        mov  TWord1, MF_ENABLED         ; Set 'true' condition
        mov  TWord2, TRUE               ; Set 'true' condition
        jmp  EdMu4                      ; Go modify the menu and toolbar
EdMu3:  mov  TWord1, MF_GRAYED          ; Set 'false' condition
        mov  TWord2, FALSE              ; Set 'false' condition
EdMu4:  inv  EnableMenuItem, hMenu, 10102, TWord1               ; Redo Menu Selection
        inv  SendMessage, hCtl, TB_ENABLEBUTTON, 10102, TWord2  ; Redo Button
        inv  IsClipboardFormatAvailable, CF_TEXT    ; Test if Clipboard is empty
        cmp  eax, TRUE                  ; Is Clipboard empty?
        jne  EdMu5                      ; Jump if no
        mov  TWord1, MF_ENABLED         ; Set 'true' condition
        mov  TWord2, TRUE               ; Set 'true' condition
        jmp  EdMu6                      ; Go modify the menu and toolbar
EdMu5:  mov  TWord1, MF_GRAYED          ; Set 'false' condition
        mov  TWord2, FALSE              ; Set 'false' condition
EdMu6:  inv  EnableMenuItem, hMenu, 10106, TWord1               ; Paste Menu Selection
        inv  SendMessage, hCtl, TB_ENABLEBUTTON, 10106, TWord2  ; Paste Button
        inv  SendMessage, hREd, EM_EXGETSEL, 0, offset cr   ; Test for 'Selected Text'
        mov  eax, cr.cpMax              ; Get 'end of highlight'
        sub  eax, cr.cpMin              ; Subtract the start value
        cmp  eax, 0                     ; Nothing selected?
        je   EdMu7                      ; Jump if nothing selected
        mov  TWord1, MF_ENABLED         ; Set 'true' condition
        mov  TWord2, TRUE               ; Set 'true' condition
        jmp  EdMu8                      ; Go modify the menu and toolbar
EdMu7:  mov  TWord1, MF_GRAYED          ; Set 'false' condition
        mov  TWord2, FALSE              ; Set 'false' condition
EdMu8:  inv  EnableMenuItem, hMenu, 10104, TWord1    ; Cut Menu Selection
        inv  EnableMenuItem, hMenu, 10105, TWord1    ; Copy Menu Selection
        inv  EnableMenuItem, hMenu, 10103, TWord1    ; Delete Menu Selection
        inv  SendMessage, hCtl, TB_ENABLEBUTTON, 10104, TWord2  ; Cut Button
        inv  SendMessage, hCtl, TB_ENABLEBUTTON, 10105, TWord2  ; Copy Button
        inv  SendMessage, hCtl, TB_ENABLEBUTTON, 10103, TWord2  ; Delete Button
        mov  Modified, 0                ; Default to 'not modified'
        inv  SendMessage, hREd, EM_GETMODIFY, 0, 0      ; Get document state
        cmp  eax, FALSE                 ; Has the document been modified?
        je   bye                        ; Jump if no
        mov  Modified, 1                ; Flag the file as needing to be saved
        .if Flag==0                     ; Has the Title been displayed?
          inv  SetWinCaption            ; Display the Title Bar message, if no
          mov  Flag, 1                  ; Remember that it was displayed, prevents flicker
        .endif                          ; End of conditional
bye:    ret                             ; Return to caller
;---------------------------------------;
EnableDisable   endp
;
;
DlgProc PROC    hWndw:HWND, iMsg:DWORD, wParam:WPARAM, lParam:LPARAM
;---------------------------------------;
        LOCAL   hCtl:HWND               ; Handle storage used by different controls
;
        .if iMsg==WM_INITDIALOG         ; First pass?  Setup?
          inv  GetDlgItem, hWndw, IDC_LINENUMBER    ; Get handle for the edit control
          mov  hCtl, eax                ; Save the handle
          push eax                      ; Save the handle on the stack
          inv  SetFocus, eax            ; Set the focus to the edit box
          pop  eax                      ; Retrieve the handle
          inv  SendMessage, eax, EM_LIMITTEXT, 8, 0 ; Control will have an 8 digit limit
        .elseif iMsg==WM_CLOSE          ; If all done ...
          inv  EndDialog, hWndw, NULL   ; Close the dialog box
        .elseif iMsg==WM_COMMAND        ; If there is a valid command to process ...
          mov eax, wParam               ; Get the command
          mov edx, eax                  ; Get a copy of the parameter value
          shr edx, 16                   ; Just the LSWord
          .if dx==BN_CLICKED            ; Was a button clicked?
            .if eax==IDC_CANCEL         ; Was it the cancel button?
              inv  SendMessage, hWndw, WM_CLOSE, NULL, NULL ; Send a close request to WM_CLOSE
            .elseif eax==IDC_OK         ; If it was the okay button
              inv  GetDlgItemInt, hWndw, IDC_LINENUMBER, 0, FALSE   ; Get line number
              mov  tempword, eax        ; Save new number
              inv  SendMessage, hWndw, WM_CLOSE, NULL, NULL ; Send a close request to WM_CLOSE
            .endif                      ; End of conditional
          .endif                        ; End of conditional
        .else                           ; else ...
          mov eax, FALSE                ; Set exit value
          ret                           ; Return to caller
        .endif                          ; End of conditional
        mov  eax, TRUE                  ; Set exit value
        ret                             ; Return to caller
;---------------------------------------;
DlgProc endp
;
;
SpecialProc proc hWin:DWORD, wmsg:DWORD, wParam:DWORD, lParam:DWORD
;---------------------------------------;
        .if wmsg == WM_INITDIALOG       ; If 'Initialize Dialog' request...
          inv  SetDlgItemText, hWin, 3007, addr szButton4   ; Set default button
          ret                           ; Return  to caller
        .elseif wmsg == WM_CLOSE        ; If 'Close Dialog' request...
          inv  EndDialog, hWin, 0       ; Close it
          push 1                        ; Set errorlevel value
          pop  eax                      ; Get it into the proper register
          ret                           ; Return  to caller
        .elseif wmsg == WM_COMMAND      ; If 'Process Command' request...
          .if wParam == IDC_REPORT      ; If button pressed...
            inv  SetDlgItemText, hWin, 3007, addr szButton4
            ret                         ; Return  to caller
          .elseif wParam == IDC_SHORTS  ; If button pressed...
            inv  SetDlgItemText, hWin, 3007, addr szButton3
            ret                         ; Return  to caller
          .elseif wParam == IDC_NOTES   ; If button pressed...
            inv  SetDlgItemText, hWin, 3007, addr szButton5
            ret                         ; Return  to caller
          .elseif wParam == IDC_ABOUT   ; If button pressed...
            inv  SetDlgItemText, hWin, 3007, addr szButton6
            ret                         ; Return  to caller
          .elseif wParam == IDCANCEL    ; If button pressed...
            inv  EndDialog, hWin, 0     ; Close the dialog box
            push 1                      ; Set errorlevel value
            pop  eax                    ; Get it into the proper register
            ret                         ; Return  to caller
          .endif                        ; End of conditional
        .endif                          ; End of conditional
        xor  eax, eax                   ; Errorlevel==0
        ret                             ; Return  to caller
;---------------------------------------;
SpecialProc endp
;
;
; ______________________________________
;|                                      |
;| Manage the MRU list in File Menu.    |
;|______________________________________|
;
AppendToMenu proc   USES ESI EDI
;---------------------------------------;
        inv  GetMenu, hWnd              ; Get handle to main menu
        mov  hMenu, eax                 ; Save the menu handle
        inv  GetSubMenu, hMenu, 0       ; Get handle to 1st popup menu
        mov  hSubMenu, eax              ; Save the submenu handle
        inv  GetMenuItemCount, hSubMenu ; Get amount of SubMenu items
        sub  eax, 1                     ; Point above the Exit selection
        mov  itemcount, eax             ; Save the index counter
        inc  Partial                    ; Count the separator
        .if Partial > 6                 ; Is the menu full?
          mov  Partial, 6               ; Maximum allowed
        .endif                          ; End of conditional
        .if isModified == 1             ; If not the first run
          mov  eax, Partial             ; How many unused entries?
          sub  itemcount, eax           ; Fix the index counter
          .while  Partial > 0           ; If not all removed
            inv  DeleteMenu, hSubMenu, itemcount, MF_BYPOSITION ; Clear the MRU
            dec  Partial                ; Count this removal
          .endw                         ; Do it 6 times at most
        .endif                          ; End of conditional
        mov  isModified, 1              ; Mark for next run
        cmp  PathName[0], 0             ; Did we 'load' or 'save as' a file?
        je   empty                      ; Jump if we did not
        cmp  PathName[0], 'U'           ; Did we 'load' or 'save as' a file?
        je   empty                      ; Jump if we did not
;       Checking for possible duplication
;       --------------------------------;
        mov  amtAdded, 5                ; Maximum entries in menu
        mov  Block, 0                   ; Point to first entry
        .while amtAdded > 0             ; Until all entries are compared
          mov  esi, offset PathName     ; Point to string to compare
          mov  edi, offset MRUDump      ; Get the Menu buffer pointer
          add  edi, Block               ; At this offset
Matches:  mov  al, [esi]                ; Get a character
          cmp  [edi], al                ; Match?
          jne  NoMatch                  ; Jump to next comparison if no
          inc  edi                      ; Update the buffer pointer
          inc  esi                      ; Update the buffer pointer
          cmp  al, 0                    ; ASCIIZ?
          je   CpyDwn                   ; If yes, we found a match
          jmp  Matches                  ; Continue parsing
NoMatch:  add  Block, 256               ; Move to next menu selection
          dec  amtAdded                 ; Count the last comparison
        .endw                           ; Do it 5 times
        mov  Block, 1024                ; Offset into the buffer
CpyDwn: cmp  Block, 0                   ; Done?
        je   empty                      ; Jump if done
        mov  edi, offset MRUDump        ; Point to the buffer
        add  edi, Block                 ; At this offset
        mov  esi, edi                   ; Point to the buffer
        sub  esi, 256                   ; At this offset
        mov  amtAdded, 256              ; Maximum entry size
        .while amtAdded > 0             ; If not all transferred
          mov  al, [esi]                ; Get a menu character
          mov  [edi], al                ; Move it to the next line
          inc  esi                      ; Update the buffer pointer
          inc  edi                      ; Update the buffer pointer
          dec  amtAdded                 ; Count the transfer
        .endw                           ; Do it 256 times
        sub  Block, 256                 ; Update the offset pointer
        cmp  Block, 0                   ; All done?
        jne  CpyDwn                     ; Go move next menu item, if not done
        mov  edi, offset MRUDump        ; Point to the first MRU menu location
        mov  esi, offset PathName       ; Point to the new filename
next1:  mov  al, [esi]                  ; Get a character
        mov  [edi], al                  ; Store it in the menu buffer
        inc  esi                        ; Update the buffer pointer
        inc  edi                        ; Update the buffer pointer
        cmp  al, 0                      ; Done?
        jne  next1                      ; Continue the copy until ASCIIZ is reached
empty:  mov  Block, 0                   ; Start at the beginning, of course
        mov  Partial, 0                 ; Clear the item counter
        mov  eax, 1201                  ; values are 1201 - 1205
again:  mov  MenuID, eax                ; wParam value
        mov  esi, offset MRUDump        ; Get Menu entry offset in buffer
        add  esi, Block                 ; This is the offset to it
        cmp  byte ptr [esi], 0          ; No more Menu Items to add?
        je   SeeYa                      ; Jump if all done
        add  Partial, 1                 ; Count this menu item
        mov  edi, offset szMenuEntry    ; Point to the data
copy:   mov  al, [esi]                  ; Get a character
        mov  [edi], al                  ; Store it in the temporary buffer
        inc  esi                        ; Update the buffer pointer
        inc  edi                        ; Update the buffer pointer
        cmp  al, 0                      ; Done?
        jne  copy                       ; Continue the transfer if not done
        add  Block, 256                 ; Update the buffer offset pointer
        inv  AddLineItem                ; Add the item to the menu
        mov  eax, MenuID                ; wParam value
        add  eax, 1                     ; Update the wParam value
        inc  itemcount                  ; Update the menu index counter
        cmp  Block, 1280                ; Done?
        jne  again                      ; Continue until all entries are added
SeeYa:  inv  AddSeparator               ; Store a separator in the menu
        inv  SaveMRUFiles               ; Update the registry
        ret                             ; Return to caller
;---------------------------------------;
AppendToMenu endp
;
;
; ______________________________________
;|                                      |
;| szMenuEntry = points to menu entry   |
;|               filename text string   |
;|      MenuID = wParam menu selection  |
;|   itemcount = menu sel. location     |
;|______________________________________|
;
AddLineItem proc
;---------------------------------------;
        LOCAL miInfo:MENUITEMINFO       ; Structure
;
        mov  miInfo.cbSize, sizeof MENUITEMINFO ; Get structure size
        mov  miInfo.fMask, MIIM_TYPE or MIIM_ID ; and type
        mov  miInfo.fType, MFT_STRING   ; Set 'type'
        inv  lstrlen, addr szMenuEntry  ; Get length of new entry
        mov  miInfo.cch, eax            ; Length of MENUITEM label
        mov  eax, offset szMenuEntry    ; Point to new entry
        mov  miInfo.dwTypeData, eax     ; Store it in the structure
        mov  miInfo.fState, MFS_ENABLED ; Menu is selectable
        mov  eax, MenuID                ; Get Menu item ID
        mov  miInfo.wID, eax            ; Store the value to be sent to wParam
        mov  miInfo.hSubMenu, NULL      ; This is a MENUITEM, not a heading
        mov  miInfo.hbmpChecked, NULL   ; Skip the graphics
        mov  miInfo.hbmpUnchecked, NULL ; Skip the graphics
        mov  miInfo.dwItemData, eax     ; Again with the ID
        inv  InsertMenuItem, hSubMenu, itemcount, TRUE, ADDR miInfo ; Add item to menu
        inv  EnableMenuItem, hSubMenu, itemcount, MF_BYCOMMAND or MF_ENABLED    ; Make it selectable
        ret                             ; Return to caller
;---------------------------------------;
AddLineItem endp
;
;
; ______________________________________
;|                                      |
;| Append a separator to bottom of menu |
;| just above the Exit selection.       |
;| itemcount contains the value of the  |
;| location on entry into this routine. |
;|______________________________________|
;
AddSeparator proc
;---------------------------------------;
        LOCAL miInfo:MENUITEMINFO       ; Structure
;
        mov  miInfo.cbSize, sizeof MENUITEMINFO ; Size of structure is stored
        mov  miInfo.fState, 0                   ; Structure data
        mov  miInfo.hSubMenu, 0                 ; Structure data - SubMenu pointer
        mov  miInfo.hbmpChecked, 0              ; Structure data
        mov  miInfo.hbmpUnchecked, 0            ; Structure data
        mov  miInfo.dwItemData, 0               ; Structure data
        mov  miInfo.fType, MFT_SEPARATOR        ; Structure data - Separator
        mov  miInfo.dwTypeData, 0               ; Structure data
        mov  miInfo.cch, 0                      ; Structure data
        mov  miInfo.wID, 0                      ; Structure data
        mov  miInfo.fMask, MIIM_TYPE            ; Structure data
        inv  InsertMenuItem, hSubMenu, itemcount, 1, ADDR miInfo    ; Insert Separator
        ret                             ; Return to caller
;---------------------------------------;
AddSeparator endp
;
;
; ______________________________________
;|                                      |
;| NOTE:  At the first blank entry, the |
;| search will end.  If you delete the  |
;| first item, this routine will report |
;| that there are NO MRU files, EVEN IF |
;| the next 4 entries all have values.  |
;| Those entries will just disappear.   |
;|______________________________________|
;
LoadMRUFiles proc   USES ESI EDI
;---------------------------------------
inv  GetRegKeysz, Addr szMRU_File1, Addr szKeyName, Addr szMRUMessage1, Addr MRUBufLen1 ; Get MRU string data
        inv  GetRegKeysz, addr szMRU_File2, addr szKeyName, addr szMRUMessage2, addr MRUBufLen2 ; Get MRU string data
        inv  GetRegKeysz, addr szMRU_File3, addr szKeyName, addr szMRUMessage3, addr MRUBufLen3 ; Get MRU string data
        inv  GetRegKeysz, addr szMRU_File4, addr szKeyName, addr szMRUMessage4, addr MRUBufLen4 ; Get MRU string data
        inv  GetRegKeysz, addr szMRU_File5, addr szKeyName, addr szMRUMessage5, addr MRUBufLen5 ; Get MRU string data
        mov  esi, offset szMRU_File1    ; Point to Registry Menu buffer
        mov  amtAdded, 0                ; Clear the line buffer counter
        mov  eax, 5                     ; Five possible items
        .while eax > 0                  ; Until all are tested
          cmp  byte ptr [esi], 0        ; Is the item empty?
          je   done                     ; Look no further if it is
          add  amtAdded, 256            ; increase the transfer size
          add  esi, 256                 ; Move to the next entry
          dec  eax                      ; Count this comparison
        .endw                           ; Do it 5 times
done:   mov  edi, offset MRUDump        ; Point to the Menu buffer
        mov  esi, offset szMRU_File1    ; Point to Registry Menu buffer
        .while amtAdded > 0             ; Until all bytes are transferred
          mov  al, [esi]                ; Get a byte from the Registry buffer
          mov  [edi], al                ; Store it in the Menu buffer
          inc  esi                      ; Update the buffer pointer
          inc  edi                      ; Update the buffer pointer
          dec  amtAdded                 ; Count the byte
        .endw                           ; Transfer is complete
        mov  esi, offset EndOfDump      ; End of buffer pointer
again:  cmp  esi, edi                   ; all erased?
        je   bye                        ; Jump if done
        mov  byte ptr [edi], 0          ; Clear a character
        inc  edi                        ; Update the buffer pointer
        jmp  again                      ; Continue clearing unused portion of buffer
bye:    ret                             ; Return to caller
;---------------------------------------;
LoadMRUFiles endp
;
;
SaveMRUFiles proc   USES ESI EDI
;---------------------------------------;
        mov  amtAdded, 1280             ; Menu buffer size
        mov  esi, offset MRUDump        ; Point to the Menu buffer
        mov  edi, offset szMRU_File1    ; Point to the Registry Menu Buffer
        .while amtAdded > 0             ; Until all bytes are transferred
          mov  al, [esi]                ; Get a character from the Menu buffer
          mov  [edi], al                ; Store it in the Registry buffer
          inc  esi                      ; Update the buffer pointer
          inc  edi                      ; Update the buffer pointer
          dec  amtAdded                 ; Count the byte transfer
        .endw                           ; Transfer is complete
        inv  lstrlen, addr szMRU_File1  ; Get length of string
        mov  szStrLength, eax           ; Save it
        inv  SetRegKeysz, addr szMRU_File1, addr szKeyName, addr szMRUMessage1, szStrLength ; Write the string
        inv  lstrlen, addr szMRU_File2  ; Get length of string
        mov  szStrLength, eax        ; Save it
        inv  SetRegKeysz, addr szMRU_File2, addr szKeyName, addr szMRUMessage2, szStrLength ; Write the string
        inv  lstrlen, addr szMRU_File3  ; Get length of string
        mov  szStrLength, eax           ; Save it
        inv  SetRegKeysz, addr szMRU_File3, addr szKeyName, addr szMRUMessage3, szStrLength ; Write the string
        inv  lstrlen, addr szMRU_File4  ; Get length of string
        mov  szStrLength, eax        ; Save it
        inv  SetRegKeysz, addr szMRU_File4, addr szKeyName, addr szMRUMessage4, szStrLength ; Write the string
        inv  lstrlen, addr szMRU_File5  ; Get length of string
        mov  szStrLength, eax           ; Save it
        inv  SetRegKeysz, addr szMRU_File5, addr szKeyName, addr szMRUMessage5, szStrLength ; Write the string
        ret                             ; Return to caller
;---------------------------------------;
SaveMRUFiles endp
;
;
GetRegKeysz Proc lpszBuffer:DWord, lpszKeyName:DWord, lpszValueName:DWord, dwStringLength:DWord
;---------------------------------------;
        LOCAL TType:DWORD               ; Scratch variable
        LOCAL pKey:DWORD                ; Scratch variable
;
        mov  TType, REG_SZ              ; Set size
        inv  RegCreateKeyEx, HKEY_LOCAL_MACHINE, lpszKeyName, NULL, NULL,
             REG_OPTION_NON_VOLATILE, KEY_ALL_ACCESS, NULL, addr pKey, addr TType   ; Create key
        .if eax == ERROR_SUCCESS        ; If successful...
          mov  eax, REG_DWORD           ; Get key
          mov  TType, eax               ; Save key
          inv  RegQueryValueEx, pKey, lpszValueName,
               NULL, ADDR TType, lpszBuffer, dwStringLength ; Get value
          inv  RegCloseKey, pKey        ; Close the Registry
        .endif                          ; End of conditional
        ret                             ; Return  to caller
;---------------------------------------;
GetRegKeysz endp
;
;
SetRegKeysz Proc lpszString:DWord, lpszKeyName:DWord, lpszValueName:DWord, dwStringLength:DWord
;---------------------------------------;
        LOCAL Disp:DWORD                ; Scratch variable
        LOCAL pKey:DWORD                ; Scratch variable
;
        inv  RegCreateKeyEx, HKEY_LOCAL_MACHINE, lpszKeyName, NULL, NULL,
             REG_OPTION_NON_VOLATILE, KEY_ALL_ACCESS, NULL, addr pKey, addr Disp    ; Create key
        .if eax == ERROR_SUCCESS        ; If successful...
          inv  RegSetValueEx, pKey, lpszValueName,
               NULL, REG_SZ, lpszString, dwStringLength ; Store the key
          inv  RegCloseKey, pKey        ; Close the Registry
        .endif                          ; End of conditional
        ret                             ; Return  to caller
;---------------------------------------;
SetRegKeysz endp
;
;
GetRegKeyDW Proc lpdwValue:DWord,lpszKeyName  :DWORD,lpszValueName:DWord
;---------------------------------------;
        LOCAL Temp:DWORD                ; Scratch variable
        LOCAL pKey:DWORD                ; Scratch variable
        LOCAL DWordSize:DWORD           ; Scratch variable
        DW_SIZE equ 4                   ; Scratch variable
;
        mov  DWordSize, DW_SIZE         ; Get size of data
        inv  RegCreateKeyEx, HKEY_LOCAL_MACHINE, lpszKeyName, NULL, NULL,
             REG_OPTION_NON_VOLATILE, KEY_ALL_ACCESS, NULL, addr pKey, addr Temp    ; Get entry key
        .if eax == ERROR_SUCCESS        ; If successful
          mov  eax, REG_DWORD           ; Get the key
          mov  Temp, eax                ; Save it in the temporary buffer
          inv  RegQueryValueEx, pKey, lpszValueName,
               NULL, ADDR Temp, lpdwValue, ADDR DWordSize   ; Get value
          inv  RegCloseKey, pKey        ; Close the Registry
        .endif                          ; End of conditional
        ret                             ; Return  to caller
;---------------------------------------;
GetRegKeyDW endp
;
;
SetRegKeyDW Proc lpdwValue:DWord, lpszKeyName:DWord, lpszValueName:DWord
;---------------------------------------;
        LOCAL Disp:DWORD                ; Scratch variable
        LOCAL pKey:DWORD                ; Scratch variable
        DW_SIZE equ 4                   ; Scratch variable
;
        inv  RegCreateKeyEx, HKEY_LOCAL_MACHINE, lpszKeyName, NULL, NULL,
             REG_OPTION_NON_VOLATILE, KEY_ALL_ACCESS, NULL, addr pKey, addr Disp    ; Create the entry key
        .if eax == ERROR_SUCCESS        ; If successful...
          inv  RegSetValueEx, pKey, lpszValueName,
               NULL, REG_DWORD_LITTLE_ENDIAN, lpdwValue, DW_SIZE    ; Write the data to the registry
          inv  RegCloseKey, pKey        ; Close the Registry file
        .endif                          ; End of conditional
        ret                             ; Return to caller
;---------------------------------------;
SetRegKeyDW endp
;
;
GtFrmRegistry proc
;---------------------------------------
GetIt:  inv  GetRegKeysz, addr szFontName, addr szKeyName, addr szFontMessage, addr FNBufferLength  ; Read FontName
        inv  GetRegKeyDW, ADDR szBgColor, ADDR szKeyName, ADDR szBGCMessage     ; Read Background Color
        inv  GetRegKeyDW, ADDR szFgColor, ADDR szKeyName, ADDR szFGCMessage     ; Read Text Color
        inv  GetRegKeyDW, ADDR szPointSize, ADDR szKeyName, ADDR szPointMessage ; Read Point Size
        inv  GetRegKeyDW, ADDR szFontHeight, ADDR szKeyName, ADDR szFHeightMsg  ; Read Font Height
        inv  GetRegKeyDW, ADDR szFontWeight, ADDR szKeyName, ADDR szFWeightMsg  ; Read Font Weight
        .if szBgColor==0                ; If nothing is in the Registry
          inv  SavToRegistry            ; Initialize the Registry
          jmp  GetIt                    ; Go try again, this time you will succeed
        .endif                          ; End of conditional
        inv  lstrcpy, ADDR FontName, ADDR szFontName    ; Store FontName
        m2m  BgColor, szBgColor         ; Store Background Color
        m2m  rgb, szFgColor             ; Store Text Color
        m2m  PointSize, szPointSize     ; Store Point Size
        m2m  FontHeight, szFontHeight   ; Store Font Height
        m2m  FontWeight, szFontWeight   ; Store Font Weight
        ret                             ; Return to caller
;---------------------------------------;
GtFrmRegistry endp
;
;
SavToRegistry proc
;---------------------------------------
        inv  lstrcpy, ADDR szFontName, ADDR FontName    ; Get FontName
        m2m  szBgColor, BgColor                         ; Get Background Color
        m2m  szFgColor, rgb                             ; Get Text Color
        m2m  szPointSize, PointSize                     ; Get Point Size
        m2m  szFontHeight, FontHeight                   ; Get Font Height
        m2m  szFontWeight, FontWeight                   ; Get Font Weight
        inv  SetRegKeysz, addr szFontName, addr szKeyName, addr szFontMessage, sizeof szFontMessage ; Write FontName
        inv  SetRegKeyDW, ADDR szBgColor, ADDR szKeyName, ADDR szBGCMessage     ; Write Background Color
        inv  SetRegKeyDW, ADDR szFgColor, ADDR szKeyName, ADDR szFGCMessage     ; Write Text Color
        inv  SetRegKeyDW, ADDR szPointSize, ADDR szKeyName, ADDR szPointMessage ; Write Point Size
        inv  SetRegKeyDW, ADDR szFontHeight, ADDR szKeyName, ADDR szFHeightMsg  ; Write Font Height
        inv  SetRegKeyDW, ADDR szFontWeight, ADDR szKeyName, ADDR szFWeightMsg  ; Write Font Weight
        ret                             ; Return to caller
;---------------------------------------;
SavToRegistry endp
;
;
PrintProc proc USES EBX ESI EDI
;---------------------------------------
        LOCAL Chg:DWORD, TextSize
        LOCAL cf:CHOOSEFONT             ; Structure
;
        inv  SendMessage, hREd, EM_GETMODIFY, 0, 0
        mov  Chg, eax
        push cf.rgbColors
        mov  cf.rgbColors, 0
        inv  SendMessage, hREd, EM_SETBKGNDCOLOR, 0, 00ffffffh
        pop  cf.rgbColors
        cmp  PrtColor, 1
        je   StartPrt
        inv  SendMessage, hREd, EM_EXGETSEL, 0, offset cr
        inv  SendMessage, hREd, EM_SETSEL, -1, 0
        mov  charF.dwMask, CFM_FACE or CFM_SIZE or CFM_COLOR
        mov  charF.crTextColor, 0
        inv  lstrcpy, offset charF.szFaceName, offset FontName
        inv  SendMessage, hREd, EM_SETCHARFORMAT, SCF_ALL, offset charF
        inv  SendMessage, hREd, EM_EXSETSEL, 0, offset cr
StartPrt:
        mov  cnt, 0
        mov  pd.lStructSize, sizeof pd
        mov  eax, hWnd
        mov  pd.hwndOwner, eax
        mov  eax, hInstance
        mov  pd.hInstance, eax
        mov  pd.Flags, PD_RETURNDC
        inv  PrintDlg, offset pd
        cmp  eax, FALSE
        je   PrtRet
        mov  eax, pd.Flags
        mov  ebx, eax
        and  ebx, 000000ffh
        mov  Sel, ebx
        inv  SendMessage, hREd, EM_EXGETSEL, 0, offset cr
        mov  eax, cr.cpMax
        .if eax > cr.cpMin && Sel != 1
          MsgBox ERROR_NO_SELECTION, szSelect, MB_YESNO or MB_ICONQUESTION
          cmp  eax, IDNO
          je   PrtRet
        .endif
        mov  doci.cbSize, sizeof doci
        mov  doci.lpszDocName, offset pTitle
        mov  doci.lpszOutput, 0
        mov  doci.fwType, 0
        mov  eax, pd.hDC
        mov  fr_1.hdc, eax
        mov  fr_1.hdcTarget, eax  ;0
        inv  GetDeviceCaps, fr_1.hdc, LOGPIXELSX    ; Number of pixels per logical inch along the screen width.
        mov  xPerInch, eax
        inv  GetDeviceCaps, fr_1.hdc, LOGPIXELSY    ; Number of pixels per logical inch along the screen height.
        mov  yPerInch, eax
        mov  eax, mL                    ; Min is 360
        mov  rect_1.left, eax
        mov  eax, mT                    ; Min is 360
        mov  rect_1.top, eax
        .if PrtHead
          add  rect_1.top, 420          ; 360
        .endif
        inv  GetDeviceCaps, fr_1.hdc, HORZRES       ; Width, in pixels, of the screen.
        mov  ecx, 1440
        mul  ecx
        div  xPerInch
        mov  rect_1.right, eax
        mov  eax, mR                    ; Min is 360
        sub  rect_1.right, eax
        inv  GetDeviceCaps, fr_1.hdc, VERTRES       ; Height, in raster lines, of the screen.
        mov  ecx, 1440
        mul  ecx
        div  yPerInch
        mov  rect_1.bottom, eax
        mov  eax, mB                    ; Min is 302
        sub  rect_1.bottom, eax
        mov  ecx, 16
        mov  edi, offset fr_1.rcPage
        mov  esi, offset rect_1
        cld
        rep  movsb
        inv  StartDoc, pd.hDC, offset doci
        inv  SendMessage, hREd, EM_EXGETSEL, 0, offset cr
        mov  eax, cr.cpMin
        mov  ebx, cr.cpMax
        .if ebx > eax && Sel == 1
          mov  fr_1.chrg.cpMin, eax
          mov  fr_1.chrg.cpMax, ebx
          mov  TextSize, ebx
        .else
          inv  SendMessage, hREd, EM_HIDESELECTION, 1, 0
          mov  cr.cpMin, 0
          mov  cr.cpMax, -1
          inv  SendMessage, hREd, EM_EXSETSEL, 0, offset cr
          inv  SendMessage, hREd, EM_EXGETSEL, 0, offset cr
          MOVmd fr_1.chrg.cpMin, cr.cpMin
          mov  fr_1.chrg.cpMax, -1
          MOVmd TextSize, cr.cpMax
          mov  cr.cpMin, 0
          mov  cr.cpMax, 0
          inv  SendMessage, hREd, EM_EXSETSEL, 0, offset cr
          inv  SendMessage, hREd, EM_HIDESELECTION, 0, 0
        .endif
prtloop:
        inv  StartPage, pd.hDC
        cmp  eax, 0
        jle  prtabort
        mov  ecx, 16
        mov  esi, offset rect_1
        mov  edi, offset fr_1.rc        ; Actual print page dimensions
        cld
        rep  movsb
        inv  SendMessage, hREd, EM_FORMATRANGE, TRUE, offset fr_1   ; Print page
        mov  fr_1.chrg.cpMin, eax
        inv  EndPage, pd.hDC
        cmp  eax, 0
        jle  prtabort
        mov  eax, fr_1.chrg.cpMin
        cmp  eax, 0
        jle  prtdone
        cmp  eax, TextSize
        jl   prtloop
prtdone:
        inv  SendMessage, hREd, EM_FORMATRANGE, 0, 0
        inv  EndDoc, pd.hDC
        inv  DeleteDC, pd.hDC
        jmp  PrtRet
prtabort:
        inv  AbortDoc, fr_1.hdc
PrtRet:
        .if ExtType != 'r' && ExtType + 1 != 't' && ExtType + 2 != 'f' || RTF == 0
          inv  SendMessage, hREd, EM_SETBKGNDCOLOR, 0, BackGC
          MOVmd charF.crTextColor, TextC
          inv  lstrcpy, offset charF.szFaceName, offset FontName
          inv  SendMessage, hREd, EM_SETCHARFORMAT, SCF_ALL, offset charF
        .endif
        MOVmd EBook, SBook
        inv  SendMessage, hREd, EM_SETSEL, SBook, EBook
        inv  SendMessage, hREd, EM_SETMODIFY, Chg, 0
        ret
;---------------------------------------
PrintProc endp
;
;
DoPageSU proc
;---------------------------------------
        mov  psd.lStructSize, sizeof psd
        push hWnd
        pop  psd.hwndOwner
        push hInstance
        pop  psd.hInstance
        mov  psd.Flags, PSD_MARGINS or PSD_INTHOUSANDTHSOFINCHES or PSD_DISABLEPAPER or PSD_DISABLEPRINTER
        inv  PageSetupDlg, offset psd
        cmp  eax,0
        jz   NSU
        finit
        mov  al, byte ptr psd.rtMargin[0]
        mov  ah, byte ptr psd.rtMargin[1]
        and  eax, 0000ffffh
        mov  w1, eax
        fld  RTwips1000
        fild w1
        fmul ST(0), ST(1)
        fistp mL
        mov  al, byte ptr psd.rtMargin[4]
        mov  ah, byte ptr psd.rtMargin[5]
        and  eax, 0000ffffh
        mov  w1, eax
        fld  RTwips1000
        fild w1
        fmul ST(0), ST(1)
        fistp mT
        mov  al, byte ptr psd.rtMargin[8]
        mov  ah, byte ptr psd.rtMargin[9]
        and  eax, 0000ffffh
        mov  w1, eax
        fld  RTwips1000
        fild w1
        fmul ST(0), ST(1)
        fistp mR
        mov  al, byte ptr psd.rtMargin[12]
        mov  ah, byte ptr psd.rtMargin[13]
        and  eax, 0000ffffh
        mov  w1, eax
        fld  RTwips1000
        fild w1
        fmul ST(0), ST(1)
        fistp mB
        sub  mL, 360
        sub  mT, 360
        sub  mR, 360
        sub  mB, 302
NSU:    ret
;---------------------------------------
DoPageSU endp
; _____________________________
;|                             |
;| Generate error message      |
;|  eax = message # to display |
;|  ebx = Title                |
;|  ecx = MessageBox Flags     |
;|_____________________________|
;
ErrorMsg    proc
;---------------------------------------;
        push ecx                        ;
        push ebx                        ; Save these for after LoadString call
        push lengthof szWork            ; Size of our buffer
        push offset szWork              ; Buffer to load string into
        push eax                        ; Resource #
        push hInstance                  ; Instance
        call LoadString                 ; Load the tip from STRINGTABLE
        cmp  eax, 0                     ; Did we get a string?
        jne  Error1                     ; Yes, continue
        lea  eax, szNULL                ; Null string
Error1: push offset szWork
        push 0
        call MessageBox
        ret
;-------------------------------------
ErrorMsg    endp
; ________________________________________________
;|                                                |
;| ASCII Box Procedure - ASCII Win is a Sub Class |
;|________________________________________________|
;
AsciiProc   proc  hwnd:DWORD, wmsg:DWORD, wparam:DWORD, lparam:DWORD
;---------------------------------------
        .if wmsg == WM_CHAR
          MOVmd w4, wmsg
          inv  BaseAscii, wparam, offset szBuff, 0, 10, 0, 0, 1
          inv  BaseAscii, wparam, offset Misc, 0, 16, 0, 0, 1
          inv  SendMessage, hAsciibox, EM_SETSEL, 0, -1
        .endif
        inv  CallWindowProc, lpAsciibox, hwnd, wmsg, wparam, lparam
        ret
;---------------------------------------
AsciiProc   endp
; ________________________
;|                        |
;| ASCII DIALOG PROCEDURE |
;|________________________|
;
AsciiDlg    proc    hdlg:DWORD, wmsg:DWORD, wparam:DWORD, lparam:DWORD
;---------------------------------------
        cmp  wmsg, WM_COMMAND
        jne  AsciiDone
        mov  eax, wparam
        cwde
        .if eax ==  IDM_ASCII && w4 == WM_CHAR
          inv  SetDlgItemText, hdlg, E1, offset szBuff
          inv  SetDlgItemText, hdlg, E2, offset Misc
          jmp  AsciiDone
        .endif
        cmp  eax, IDCANCEL
        jne  AsciiDone
        inv  EndDialog, hdlg, wparam
        mov  eax, TRUE
        jmp  AsciiRet
AsciiDone:
        and  w4, 0
        mov  eax, FALSE
AsciiRet:
        ret
;---------------------------------------
AsciiDlg    endp
; _____________________________________________________________________
;|                                                                     |
;| Converts a 32 bit num value to a Dec, Hex, Oct or Bin ascii string. |
;|_____________________________________________________________________|
;
BaseAscii   proc    USES EBX ESI EDI InPut:DWORD, OutPut:DWORD, LEN:DWORD, Base:DWORD, Comma:DWORD, Fill:DWORD, TermA:DWORD
;---------------------------------------
        LOCAL LBuff[32]: BYTE
;
        pushad
        xor  esi, esi
        mov  eax, InPut                 ; Input
        mov  ebx, OutPut
        mov  byte ptr [ebx], '0'
        .while (eax)
          xor  edx, edx
          div  Base                     ; Base 10, 16, 8, 2
          .if dl > 9h
            add  dl, 37h                ; Convert to hex ASCII
          .else
            add  dl, 30h                ; Convert to dec ASCII
          .endif
          mov  LBuff[esi], dl
          inc  esi
          .if Comma == 1 && Base == 10 && eax > 0
            .if esi == 3 || esi == 7 || esi == 11
              mov  LBuff[esi], 2ch      ; Insert commas
              inc  esi
            .endif
          .endif
        .endw
        xor  edi, edi
        mov  ecx, esi
        .if LEN > ecx && Fill == 1      ; Zero fill
          xor  eax, eax
          .while (eax < LEN)
            mov  byte ptr [ebx+eax], '0'
            inc  eax
          .endw
          sub  LEN, ecx
          add  edi, LEN
        .endif
        .while (ecx)
          mov  al, byte ptr LBuff[esi-1]
          mov  byte ptr [ebx+edi], al
          inc  edi
          dec  esi
          dec  ecx
        .endw
        .if TermA
          mov  byte ptr [ebx+edi], 0h
        .endif
        popad
        ret
;---------------------------------------
BaseAscii   endp
;
;
HyperLinkWndProc PROC USES EBX HWnd:DWORD,
                      uMsg:DWORD,
                      wParam:DWORD,
                      lParam:DWORD
;---------------------------------------
        Local   tmpFont:LOGFONT
        Local   rect:RECT
        Local   pt:POINT
;
        mov     eax, uMsg
        .if eax==WM_NCHITTEST
          mov     eax, 1                ; We want to handle the non client hit test so we return true or 1
          ret
        .elseif eax == WM_CTLCOLORSTATIC
          push    ebx
          push    edx
          invoke  SendMessage, HWnd, WM_GETFONT, 0, 0
          mov     edx, eax
          invoke  GetObject, edx, sizeof LOGFONT, addr tmpFont
          mov     tmpFont.lfUnderline, TRUE
          invoke  CreateFontIndirect, addr tmpFont
          mov     ebx, eax
          invoke  SelectObject, wParam, ebx
          .if hover == FALSE
            invoke  SetTextColor, wParam, Blue
          .else
            invoke  SetTextColor, wParam, Red
          .endif
          invoke  GetSysColor, COLOR_MENU
          invoke  SetBkColor, wParam, eax
          invoke  DeleteObject, ebx
          invoke  GetStockObject, HOLLOW_BRUSH
          pop     edx
          pop     ebx
          ret
        .elseif eax==WM_MOUSEMOVE
          invoke  GetParent, HWnd
          push    ebx
          mov     ebx, eax
          invoke  GetActiveWindow
          .if eax == ebx
            invoke  GetCursorPos, addr pt
            invoke  GetWindowRect, HWnd, addr rect
            invoke  PtInRect, addr rect, pt.x, pt.y
            .if eax
              invoke  GetCapture
              .if !eax
                invoke  SetCapture, HWnd
                mov     hover, TRUE
                invoke  InvalidateRect, HWnd, FALSE, FALSE
                invoke  SetCursor, hFinger
              .endif
            .else
              invoke  GetCapture
              .if eax
                invoke  ReleaseCapture
                mov     hover, FALSE
                invoke  InvalidateRect, HWnd, FALSE, FALSE
              .endif
            .endif
          .endif
          pop     ebx
          xor     eax, eax
          ret
        .elseif eax==WM_LBUTTONDOWN
          invoke  GetWindowText, HWnd, offset buff, sizeof buff ; Change this for using a preset url
          invoke  ShellExecute, NULL, offset szOpen, offset buff, NULL, NULL, SW_MAXIMIZE   ; Change this to represent your preset url
          mov     hover, FALSE
          invoke  InvalidateRect, HWnd, FALSE, FALSE
          invoke  SendMessage, HWnd, WM_GETFONT, 0, 0           ; Get the defualt system font
          mov     edx, eax                                      ; Store result
          invoke  GetObject, edx, sizeof LOGFONT, addr tmpFont  ; Get our font into a logfont structure
          mov     tmpFont.lfUnderline, TRUE                     ; Under line the link
          invoke  CreateFontIndirect, addr tmpFont              ; Create the new font
          mov     ebx, eax                                      ; We need the return to free the memory later
          invoke  SelectObject, wParam, ebx                     ; Select our control
          invoke  SetTextColor, wParam, Blue                    ; Change this to change the color of the link
          xor     eax, eax                                      ; No errors
          ret                                                   ; Return
        .endif
        invoke  CallWindowProc, orgStatic, HWnd, uMsg, wParam, lParam   ;Passes message information to the next stop
        ret                                                 ; Return
;---------------------------------------
HyperLinkWndProc endp
;
;
AboutDlgProc proc hwnd:HWND, iMsg:DWORD, wParam:WPARAM, lParam:LPARAM
;---------------------------------------
        mov     eax, iMsg
        .if eax==WM_INITDIALOG
          invoke  GetDlgItem, hwnd, IDC_URL
          invoke  SetWindowLong, eax, GWL_WNDPROC, ADDR HyperLinkWndProc
          mov     orgStatic, eax
          mov     hFinger, eax
          xor     eax, eax
          ret
        .elseif eax == WM_CTLCOLORSTATIC
          invoke  SendMessage, lParam, iMsg, wParam, lParam
          ret
        .elseif eax==WM_CLOSE
          invoke  EndDialog, hwnd, NULL
        .elseif eax==WM_COMMAND
          push    edx
          mov     eax, wParam
          mov     edx, eax
          shr     edx, 16
          .if eax==IDC_EXIT
            invoke  SendMessage, hwnd, WM_CLOSE, NULL, NULL
            invoke  EndDialog, hwnd, NULL
          .endif
          pop     edx
        .else
          mov     eax, FALSE
          ret
        .endif
        mov      eax, TRUE
        ret
;---------------------------------------
AboutDlgProc endp
;
;
ShowTools proc  USES ESI
;---------------------------------------
        Local   TWord1:DWord            ; Scratch variable
        Local   DeleteMe[MAX_PATH]:Byte ; Temporary buffer
;
        lea  esi, ExtType               ; Pointer to extension
        push esi                        ; Save the pointer
        mov  ecx, 4                     ; 4 char in buffer
        inv  LowerCase                  ; Convert extension to lowercase
        pop  esi                        ; Restore the pointer
        inv  lstrcmp,ADDR ExtType, ADDR ASM ; Assembly source file?
        je   AddItems                   ; Jump if yes
        inv  lstrcmp,ADDR ExtType+1, ADDR RC    ; Resource file?
        je   AddItems                   ; Jump if yes
        Mov  TWord1, MF_GRAYED          ; Set 'false' condition
        inv  GetMenu, hWnd              ; Get handle to main menu
        Mov  hMenu, eax                 ; Save the menu handle
        inv  GetSubMenu, hMenu, 4       ; Get handle to 1st popup menu
        Mov  hSubMenu, eax              ; Save the submenu handle
        inv  EnableMenuItem, hSubMenu, 12000, TWord1    ; Disable the menu item
        inv  EnableMenuItem, hSubMenu, 12001, TWord1    ; Disable the menu item
        inv  EnableMenuItem, hSubMenu, 12002, TWord1    ; Disable the menu item
        inv  EnableMenuItem, hSubMenu, 12003, TWord1    ; Disable the menu item
        inv  EnableMenuItem, hSubMenu, 12004, TWord1    ; Disable the menu item
        inv  EnableMenuItem, hSubMenu, 12005, TWord1    ; Disable the menu item
        inv  EnableMenuItem, hSubMenu, 12006, TWord1    ; Disable the menu item
        ret                             ; Bye
AddItems:
        Mov  TWord1, MF_ENABLED         ; Set 'Enabled' condition
        inv  GetMenu, hWnd              ; Get handle to main menu
        Mov  hMenu, eax                 ; Save the menu handle
        inv  GetSubMenu, hMenu, 4       ; Get handle to 1st popup menu
        Mov  hSubMenu, eax              ; Save the submenu handle
        inv  EnableMenuItem, hSubMenu, 12000, TWord1    ; Enable the menu item
        inv  EnableMenuItem, hSubMenu, 12001, TWord1    ; Enable the menu item
        inv  EnableMenuItem, hSubMenu, 12002, TWord1    ; Enable the menu item
;;;;        inv  EnableMenuItem, hSubMenu, 12003, TWord1    ; Enable the menu item
        inv  EnableMenuItem, hSubMenu, 12004, TWord1    ; Enable the menu item
;;;;        inv  EnableMenuItem, hSubMenu, 12005, TWord1    ; Enable the menu item
        inv  EnableMenuItem, hSubMenu, 12006, TWord1    ; Enable the menu item
        inv  NameFromPath, Offset PathName, Offset ProjectName  ; Extract the filename
        lea  esi, ProjectName           ; Point to the filename
Parse:  cmp  byte ptr [esi], 2Eh        ; Parse the filenme, looking for the period
        je   Done                       ; Jump if it is fouu
        inc  esi                        ; Update the buffer pointer
        jmp  Parse                      ; Continue parsing
Done:   mov  byte ptr [esi], 0          ; ASCIIZ terminate
        inv  RtlZeroMemory, Addr szASMName, SizeOf szASMName    ; Clear the buffer
        inv  RtlZeroMemory, Addr szOBJName, SizeOf szOBJName    ; Clear the buffer
        inv  RtlZeroMemory, Addr szRCName, SizeOf szRCName  ; Clear the buffer
        inv  RtlZeroMemory, Addr szPackName, SizeOf szPackName  ; Clear the buffer
        inv  RtlZeroMemory, Addr DeleteMe, SizeOf DeleteMe  ; Clear the buffer
        inv  lstrcpy, Addr DeleteMe, Offset ProjectName     ; Get the name of the file
        inv  lstrcat, Addr DeleteMe, Offset OBJ             ; Add the extension
        inv  exist, Addr DeleteMe                           ; Does the file already exist
        cmp  eax, 0                                         ; Check the answer
        je   @F                                             ; Jump if no
        inv  DeleteFile, Addr DeleteMe                      ; Delete the old resource file
@@:     inv  RtlZeroMemory, Addr DeleteMe, SizeOf DeleteMe  ; Clear the buffer
        inv  lstrcpy, Addr DeleteMe, Offset ProjectName     ; Get the name of the file
        inv  lstrcat, Addr DeleteMe, Offset RES             ; Add the extension
        inv  exist, Addr DeleteMe                           ; Does the file already exist
        cmp  eax, 0                                         ; Check the answer
        je   @F                                             ; Jump if no
        inv  DeleteFile, Addr DeleteMe                      ; Delete the old resource file
@@:     inv  RtlZeroMemory, Addr DeleteMe, SizeOf DeleteMe  ; Clear the buffer
        inv  lstrcpy, Addr DeleteMe, Offset ProjectName     ; Get the name of the file
        inv  lstrcat, Addr DeleteMe, Offset RC              ; Add the extension
        inv  exist, Addr DeleteMe                           ; Does resource file exist?
        cmp  eax, 0                                         ; Check the result
        je   @F                                             ; Jump if there are no resources
        inv  lstrcpy, Addr szRCName, Offset ProjectName     ; Get the name of the file
        inv  lstrcat, Addr szRCName, Offset RC              ; Add the extension
        mov  RCFlag, 1                                      ; Remember that a resource exists
@@:     inv  RtlZeroMemory, Addr DeleteMe, SizeOf DeleteMe  ; Clear the buffer
        inv  lstrcpy, Addr DeleteMe, Offset ProjectName     ; Get the name of the file
        inv  lstrcat, Addr DeleteMe, Offset ASM             ; Add the extension
        inv  exist, Addr DeleteMe                           ; Does an assembly source file exist?
        cmp  eax, 0                                         ; Check the result
        je   @F                                             ; Jump if there is no source file
        inv  lstrcpy, Addr szASMName, Offset ProjectName    ; Get the name of the file
        inv  lstrcat, Addr szASMName, Offset ASM            ; Add the extension
        mov  ASMFlag, 1                                     ; Remember that a source file exists
@@:     inv  lstrcpy, Addr szPackName, Offset ProjectName   ; Get the name of the file
        inv  lstrcat, Addr szPackName, Offset EXE           ; Add the extension
        inv  lstrcpy, Addr szOBJName, Offset ProjectName    ; Get the name of the file
        inv  lstrcat, Addr szOBJName, Offset OBJ            ; Add the extension
        cmp  RCFlag, 0                                      ; Check the result
        je   @F                                             ; Jump if no resources are found
        inv  lstrcat, Addr szOBJName, Offset Space          ; Add Separator
        inv  lstrcat, Addr szOBJName, Offset ProjectName    ; Add the name of the file
        inv  lstrcat, Addr szOBJName, Offset RES            ; Add the extension
@@:     ret                                                 ; Return
;---------------------------------------
ShowTools endp
;
;
;---------------------------------------;
;  esi = input string pointer           ;
;  ecx = len get before call            ;
;  esi = output string pointer          ;
;---------------------------------------
LowerCase PROC  USES ESI EDI
;---------------------------------------
        push    esi                     ; Save pointer
        mov     edi, esi                ; dest = source
struplp:
        lodsb                           ; Get byte in al
        cmp     al, 'A'                 ; Convert
        jl      strupst                 ; only
        cmp     al, 'Z'                 ; A-Z
        jg      strupst                 ; to upper case
        add     al, 20h                 ; Add 20h to upper case bit
strupst:
        stosb                           ; store al
        loop    struplp                 ; for length of string
        pop     esi                     ; Restore string ptr
        ret                             ; Return to caller
;---------------------------------------
LowerCase ENDP
;
;
RemoveFileExt proc lpFileName:DWORD
;---------------------------------------
	invoke lstrlen,lpFileName
	mov		edx,lpFileName
	.while eax
		dec		eax
		.if byte ptr [edx+eax]=='.'
			mov		byte ptr [edx+eax],0
			.break
		.endif
	.endw
	ret
;---------------------------------------
RemoveFileExt endp
;
;
RemoveFileName proc lpFileName:DWORD
;---------------------------------------
	invoke lstrlen,lpFileName
	mov		edx,lpFileName
	.while eax
		dec		eax
		.if byte ptr [edx+eax]=='\'
			mov		byte ptr [edx+eax+1],0
			.break
		.endif
	.endw
	ret
;---------------------------------------
RemoveFileName endp
;
;
OutputMake proc nCommand:DWORD,lpFileName:DWORD
;---------------------------------------
	LOCAL	startupinfo:STARTUPINFO
	LOCAL	pinfo:PROCESS_INFORMATION
	LOCAL	buffer[256]:BYTE
	LOCAL	buffer2[256]:BYTE
	LOCAL	outbuffer[512]:byte
;
	invoke LoadCursor,0,IDC_WAIT
	invoke SetCursor,eax
	mov		outbuffer,0
	mov		eax,nCommand
	.if eax==IDM_MAKE_COMPILE
		invoke lstrcpy,addr outbuffer,offset CompileRC
		;Try FileName.rc
		invoke lstrcpy,addr buffer2,lpFileName
		invoke RemoveFileExt,addr buffer2
		invoke lstrcat,addr buffer2,offset ExtRC
		invoke GetFileAttributes,addr buffer2
		.if eax==-1
			;FileName.rc not found, try rsrc.rc
			mov		lpFileName,offset rsrcrc
			invoke RemoveFileName,addr buffer2
			invoke lstrcat,addr buffer2,lpFileName
			invoke GetFileAttributes,addr buffer2
			.if eax==-1
				;FileName.rc nor rsrc.rc found, give message and exit
                invoke MessageBox,hWnd,addr ErrorNo2,addr AboutName,MB_ICONERROR+MB_OK
				jmp		NotToday
			.endif
		.endif
		invoke lstrcat,addr outbuffer,offset szQuote
		invoke lstrcat,addr outbuffer,addr buffer2
		invoke lstrcat,addr outbuffer,offset szQuote
		mov		eax,offset ExtRes
	.elseif eax==IDM_MAKE_ASSEMBLE
		invoke lstrcpy,addr outbuffer,offset Assemble
		invoke lstrcat,addr outbuffer,offset szQuote
		invoke lstrcat,addr outbuffer,lpFileName
		invoke lstrcat,addr outbuffer,offset szQuote
		mov		eax,offset ExtObj
	.elseif eax==IDM_MAKE_LINK
		invoke lstrcpy,addr outbuffer,offset Link
		invoke lstrcpy,addr buffer2,lpFileName
		invoke RemoveFileExt,addr buffer2
		invoke lstrcat,addr buffer2,offset ExtObj
		invoke lstrcat,addr outbuffer,offset szQuote
		invoke lstrcat,addr outbuffer,addr buffer2
		invoke lstrcat,addr outbuffer,offset szQuote
		invoke RemoveFileExt,addr buffer2
		invoke lstrcat,addr buffer2,offset ExtRes
		invoke GetFileAttributes,addr buffer2
		.if eax==-1
			;FileName.res not found, try if rsrc.res exist
			invoke RemoveFileName,addr buffer2
			invoke lstrcat,addr buffer2,offset rsrcres
			invoke GetFileAttributes,addr buffer2
			.if eax!=-1
				;rsrc.res found
				invoke lstrcat,addr outbuffer,offset szSpc
				invoke lstrcat,addr outbuffer,offset szQuote
				invoke lstrcat,addr outbuffer,addr buffer2
				invoke lstrcat,addr outbuffer,offset szQuote
			.endif
		.else
			;FileName.res found
			invoke lstrcat,addr outbuffer,offset szSpc
			invoke lstrcat,addr outbuffer,offset szQuote
			invoke lstrcat,addr outbuffer,addr buffer2
			invoke lstrcat,addr outbuffer,offset szQuote
		.endif
		mov		eax,offset ExtExe
	.else
		jmp		NotToday
	.endif
	.if eax
		;Delete old file
		push	eax
		invoke lstrcpy,addr buffer2,lpFileName
		invoke RemoveFileExt,addr buffer2
		pop		eax
		invoke lstrcat,addr buffer2,eax
		invoke DeleteFile,addr buffer2
	.endif
            invoke  GetStartupInfo, addr stin
            mov     stin.cb, sizeof stin
            mov     stin.dwFlags, STARTF_USESHOWWINDOW
            mov     stin.wShowWindow, SW_SHOW
            invoke  CreateProcess, 0, addr outbuffer, 0, 0, FALSE,\
                    NORMAL_PRIORITY_CLASS, 0, 0, addr stin, addr prin
            .if eax==NULL
              invoke  MessageBox, hWnd, addr ErrorNo1, addr AboutName, MB_ICONERROR+MB_OK
              jmp     NotToday
            .else
              invoke  CloseHandle, prin.hProcess
              invoke  MessageBox, hWnd, addr ReplyNo2, addr AboutName, MB_ICONINFORMATION+MB_OK
            .endif
NotToday:
        ;;;;invoke MessageBox,hWnd,addr outbuffer,addr outbuffer,MB_ICONERROR+MB_OK
	invoke LoadCursor,0,IDC_ARROW
	invoke SetCursor,eax
        ret
;---------------------------------------
OutputMake endp
;
;
        end     start

